#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <dirent.h>
#include <utime.h>

#include "file.h"
#include "string.h"


int find_file(char *directory, char *filename, char *result)
{
    int type = 0;
    struct dirent *sDirent;
    struct stat st;

    DIR *sDir;

    char fullpath[255];

    snprintf(fullpath, 255, "%s/%s", directory, filename);
    if (file_exist(filename, directory)) {
       strncpy(result, directory, 255);

      return 1;
    }
    if ((sDir = opendir(directory))) {
 while ((sDirent = readdir(sDir))) {
        if (strcmp(sDirent->d_name, ".") && strcmp(sDirent->d_name, "..") && strcmp(sDirent->d_name, "modules")) {
         snprintf(fullpath, 255, "%s/%s", directory, sDirent->d_name);
          type = file_type(sDirent->d_name, directory, &st);
             if (S_ISDIR(type) && !S_ISLNK(type)) {
             if (find_file(fullpath, filename, result)) {
                       return 1;
                  }
          }
          }
  }
      closedir(sDir);
    }
    return 0;
}
int file_exist(char *name, char *path)
{
    struct stat st;
    char filename[255];

    if (strlen(path) > 128) {
    return 0;
    }
    if (name == NULL) {
        snprintf(filename, 255, "%s", path);
    } else {
      snprintf(filename, 255, "%s/%s", path, name);
    }

    if (stat(filename, (struct stat *) &st) != 0) {
       return 0;
    }
    return 1;
}
int file_type(char *name, char *path, struct stat *st)
{
    char filename[255];

    snprintf(filename, 255, "%s/%s", path, name);

    if (lstat(filename, (struct stat *) st) != 0) {
       return 0;
    }
    return st->st_mode;
}
/* Verify modify time */
int file_diff(char *file, char *path)
{
    struct stat source;
    struct stat object;

    char filename[255];

    snprintf(filename, 255, "%s/%s", path, file);

    stat(filename, &source);
    stat(replace_object(filename), &object);

    if (source.st_mtime != object.st_mtime) {
          return 1;
    }
    return 0;
}
/* Copy modify time */
int clone_tm(char *file, char *path)
{
    char filename[255];
    struct stat source;
    struct utimbuf ut;

    snprintf(filename, 255, "%s/%s", path, file);

    stat(filename, &source);

    ut.actime = source.st_mtime;
    ut.modtime = source.st_mtime;

    utime(replace_object(filename), &ut);

    return 1;
}
int makedir(char *prefix, char *directory)
{
    int i;
    int count = 0;
    char path[255];
    int path_size;
    char filename[255];

    if (directory[0] == '/') {
       snprintf(path, 255, "%s", directory);
    } else {
     snprintf(path, 255, "%s/%s", prefix, directory);
    }
    path_size = strlen(path);

    for (i = 0; i < path_size; i++) {
    if (path[i] == '/') {
      count++;

      if (count > 2) {
           strncpy(filename, path, i);
            filename[i] = 0x00;

           printf("Creating directory: %s\n", filename);
          mkdir(filename, 0770);
     }
  }
    }
    printf("Creating directory: %s\n", path);
    mkdir(path, 0770);

    return 1;
}
