#include <stdio.h>
#include <fcntl.h>
#include <stdlib.h>
#include <time.h>

#include "log.h"
#include "tail.h"

#define FILENAME_BIN "/var/log/NatACL"
#define FILENAME_IDX "/var/log/NatACL"

char * gen_filename_log( char * prefix, char * postfix, time_t t)
{
    char * result = NULL;
    char tmp[255];

    struct      tm      *tm;
    
    tm = localtime(&t);
    
    strftime(tmp, 255, "%Y%m%d", tm );
    
    result = calloc( 1, 255 );

    snprintf( result, 255,"%s/%s", prefix, tmp );
    mkdir( result, 0700 );

    snprintf( result, 255,"%s/%s/NatACL.%s", prefix, tmp, postfix );
    
    return result;
}

void main( int argc, char ** argv )
{
        struct s_blog_data * s_data;
        struct s_blog_hdra * s_blog;
        struct s_tail_fd * s_tail;
        char word[4096];
        char line  [4096];
        int line_size=0;
        int line_pos=0;
        int pos=0;
        char * user;
        int count=0;
	
	char * filename_idx = NULL;
	char * filename_bin = NULL;
	char * filename_temp = NULL;

        unsigned long tv;
        unsigned long addr;
        
        if( argc< 2 ){
                printf("Usage: %s <squid_log_filename>\n",argv[0]);
                exit (0 );
        }
        
        s_tail  = tail_init( argv[1] );

        while( tail_pool( s_tail ) ){
                if(tail_get_line_static( s_tail, line, 4096 , &line_size )){
                        count    = 0;
                        line_pos = 0;
                        word[0]=0;
                        while( get_word( word, 4096, line, line_size, &line_pos, ' ' , 1 ) ){   
                               /* TIME */
                               if( count == 0 ){
                                       tv = atol( word );
                               }                           
                               /* ADDRESS */
                               if( count == 2 ){
                                       addr = inet_addr( word );
				       
				       filename_temp =  gen_filename_log( FILENAME_BIN, "bin", tv );
				       if( filename_bin && filename_temp ){
				    	    if( strcmp( filename_bin, filename_temp ) ){
						free( filename_bin );
						free( filename_idx );
						filename_bin = filename_temp;

					        filename_idx =  gen_filename_log( FILENAME_IDX, "idx", tv );
	    
						blog_close( s_blog );

					        s_blog = blog_init( filename_bin, filename_idx ,O_RDONLY);        
					    }
				       } else {
				       	  filename_bin = filename_temp;
 				          filename_idx =  gen_filename_log( FILENAME_IDX, "idx", tv );

 				          s_blog = blog_init( filename_bin, filename_idx ,O_RDONLY);        
				       	  
				       }


                                        if(( pos = blog_search_interval( s_blog, tv, addr) )>0){
                                                user = blog_get_user( s_blog,  pos );
	                                        printf( "%s " , user );
                                       } else {
				    		printf( "%s ", word );
				       }
                               } else {
                                       printf( "%s " , word );
                               }
                                count ++;
                        }
                        printf( "\n" );
                        
                }
        }
}
