#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <unistd.h>
#include <unistd.h>
#include <string.h>
#include <sys/stat.h>

#include "tail.h"

char *tail_freadline( FILE *fp, int size, int * pos );
char *tail_freadline_static( FILE *fp,  char *buffer, int size, int * pos );


struct s_tail_fd * tail_init( char * filename )
{
	FILE * fp;
	int file_size;
	
	struct s_tail_fd * s_tail;
	struct stat fs;
	

	if((fp = fopen( filename, "r" ))<=0){
		return NULL;
	}
//	fseek( fp, 0L, SEEK_END );

	if( fstat( fileno(fp), &fs )!=0){
		return 0;
	}

	s_tail = calloc( 1, sizeof( struct s_tail_fd ));
	
	s_tail->fp = fp;
//	s_tail->size = fs.st_size;
	s_tail->size = 0;
	
	return s_tail;
}
int tail_pool( struct s_tail_fd * s_tail )
{
	struct stat fs;
	    
	if( fstat( fileno(s_tail->fp), &fs )!=0){
		return 1;
	}
	if( s_tail->size < fs.st_size ){
		return 1;
	}
	return 0;
}
char *tail_get_line( struct s_tail_fd * s_tail )
{
    char * line;
    int size=0;
        
    line = tail_freadline( s_tail->fp, 4096, &size );

    s_tail->size += size;
  
  
    return line;    
}
char *tail_get_line_static( struct s_tail_fd * s_tail, char * buffer, int size_max, int * readed )
{
    char * line;
    int size=0;
        
    line = tail_freadline_static( s_tail->fp, buffer, size_max, &size );

    s_tail->size += size;
  
          if( readed ){
                *readed = size;
          }
    return line;    
}

char *tail_freadline( FILE *fp, int size, int * pos )
{
    int i;
    char temp;
    char *buffer=(char *)malloc( size + 1 );
    int readed=0;
        
    i  = 0;    
    do {
	if( fread( &temp, 1, 1, fp ) <=0 ){
	    break;
	}
	if( temp!=0x0a && temp!=0x0d ){
	    buffer[i++]=temp;    
	}
	readed++;
    }while( temp !=0x0a && temp!= 0x0d && !feof(fp) && i<size );
    
    if( pos ){
 	   *pos = readed;
    }
    buffer[i]=0x00;
    
    return buffer;
}
char *tail_freadline_static( FILE *fp,  char *buffer, int size, int * pos )
{
    int i;
    char temp;
    int readed=0;
        
    i  = 0;    
    do {
	if( fread( &temp, 1, 1, fp ) <=0 ){
	    break;
	}
	if( temp!=0x0a && temp!=0x0d ){
	    buffer[i++]=temp;    
	}
	readed++;
    }while( temp !=0x0a && temp!= 0x0d && !feof(fp) && i<size );
    
    if( pos ){
 	   *pos = readed;
    }
    buffer[i]=0x00;
        
    return buffer;
}
