/***************************************************************************
    begin                : Sun Oct 05
    copyright            : (C) 2003 by Fabio Yasusi Yamamoto
    email                : fabio@hostname.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <stdarg.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <netinet/in.h>
#include <netdb.h>
#include <errno.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <time.h>
#include <sys/un.h>
#include <sys/errno.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <time.h>
#include <arpa/inet.h>

#ifdef DMALLOC
#include <dmalloc.h>
#endif
#include "util.h"

#include "sha1.h"

struct s_cmd {
    char *name;
    int code;
};

struct s_cmd s_month[] = {
    {"Jan", JAN },
    {"Feb", FEB },
    {"Mar", MAR },
    {"Apr", ARP },
    {"May", MAY },
    {"Jun", JUN },
    {"Jul", JUL },
    {"Aug", AUG },
    {"Sep", SEP },
    {"Oct", OCT },
    {"Nov", NOV },
    {"Dec", DEC },
    { NULL, 0 }
};
struct s_cmd s_weekday[] = {
    {"Mon", MON },
    {"Tue", TUE },
    {"Wed", WED },
    {"Thu", THU },
    {"Fri", FRI },
    {"Sat", SAT },
    {"Sun", SUN },
    { NULL, 0 }
};


char *sreadline(char *buffer, int size, int max_size, int *ppos, int *line_size, int *cr )
{
    char *result = NULL;
    int i;
    int pos;

    pos = *ppos;

    for (i = pos; i < size; i++) {
	if ((buffer[i] == 0x0d && buffer[i + 1] == 0x0a) || i == size - 1) {
	    if (i - pos > max_size) {
		if(!(  result = malloc(max_size + 1) )){
		    perror("malloc");
		    exit  ( 0 );
		}
		memcpy(result, &buffer[pos], max_size);
		result[max_size] = 0x00;
		*line_size = max_size;
	    } else {
		if (i - pos > 0) {
		    if(!( result = malloc(i - pos + 1) )){
		    	perror("malloc");
			exit  ( 0 );
		    }
		    memcpy(result, &buffer[pos], i - pos);
		    result[i - pos] = 0x00;
		    *line_size = i - pos;
		}
	    }
	    if( cr ){
		*cr   = 1;
	    }
	    *ppos = i + 2;
	    break;
	} else if (buffer[i] == 0x0a || i == size - 1) {
	    if (i - pos > max_size) {
		if(!( result = malloc(max_size + 1) )){
		    perror("malloc");
		    exit  ( 0 );
		}
		memcpy(result, &buffer[pos], max_size);
		result[max_size] = 0x00;
		*line_size = max_size;
	    } else {
		if (i - pos > 0) {
		    if(!( result = malloc(i - pos + 1))){
		    	perror("malloc");
			exit  ( 0 );
		    }
		    memcpy(result, &buffer[pos], i - pos);
		    result[i - pos] = 0x00;
		    *line_size = i - pos;
		}
	    }
	    if( cr ){
		cr = 0;
	    }
	    *ppos = i + 1;

	    break;
	}
    }

    return result;
}

char *add_string(char *string, int *string_size, char *msg01, ...)
{
    char temp01[100 * 1024];
    va_list args;


    va_start(args, msg01);
    vsnprintf(temp01, 100 * 1024, msg01, args);
    va_end(args);

    if (!(string = realloc(string, *string_size + strlen(temp01) + 1))) {
	perror("malloc");
	exit(0);
    }

    memcpy(&string[*string_size], temp01, strlen(temp01));

    *string_size = *string_size + strlen(temp01);

    string[*string_size] = 0x00;

    return string;
}
char *concat_string( char * original, int *original_size, char *string, int string_size )
{
    if (!(original = realloc(original, *original_size + string_size+ 1))) {
	perror("malloc");
	exit(0);
    }

    memcpy(&original[*original_size], string, string_size );

    *original_size = *original_size + string_size;

    original[*original_size] = 0x00;

    return original;
}
int checkstr(char *str, char *PERMCHAR)
{
    unsigned int i, a, c;

    int size_perm;
    int size_str;

    if (str == NULL)
	return 1;
    if (strlen(str) > 128)
	return 1;
    if (strlen(str) == 0)
	return 1;

    size_perm = strlen(PERMCHAR);
    size_str = strlen(str);

    for (i = 0; i < size_str; i++) {
	c = 0;
	for (a = 0; a < size_perm; a++) {
	    if (toupper(str[i]) == PERMCHAR[a]) {
		c = 1;
		break;
	    }
	}
	if (c == 0) {
	    return 1;
	}
    }
    return 0;
}

int str2time( char * line )
{
    char block[10][255];
    struct s_cmd * cmd;
    int s;
    int i;
    int v;
    int dia=0;
    int ano=0;
    int zone=0;
    int hora=0;
    int minuto=0;
    int segundo=0;
    
    int flag_hora=0;
    int flag_dia=0;
    int flag_ano=0;
    int flag_zone=0;
    
    int result;
    struct s_cmd * weekday = NULL;
    struct s_cmd * month   = NULL;
    char zone_hh[5];
    char zone_mm[5];
    
    struct tm tm;
    
    s = sscanf( line, "%s%s%s%s%s%s%s%s%s%s", block[0], block[1], block[2], block[3], block[4], block[5], block[6], block[7], block[8], block[9] );

    for(i=0;i<s;i++){
	if( !weekday ){
	    for (cmd = s_weekday; cmd->name != NULL; cmd++) {
		if (strncasecmp(cmd->name, block[i],strlen( block[i] )) == 0) {
		    weekday = cmd;
    		    break;
		}
	    }
	}
	if( !month ){
	    for (cmd = s_month; cmd->name != NULL; cmd++) {
		if (strncasecmp(cmd->name, block[i], strlen( block[i] )) == 0) {
		    month = cmd;
    		    break;
	        }
	    }
	}
	v = atoi( block[i] );

	if( strlen( block[i] ) == 2 && v > 0 && v < 31){
	    dia = v;
	    flag_dia = 1;
	}
	if( strlen( block[i] ) == 5 && block[i][0]=='+' || block[i][0]=='-' ){
	    strncpy( zone_hh, &block[i][1], 2 );
	    strncpy( zone_mm, &block[i][3], 2 );

	    flag_zone = 1;


	    zone_hh[2]=0x00;
	    zone_mm[2]=0x00;
	    	    
	    zone = ( atoi( zone_hh ) * 60 * 60 ) + ( atoi( zone_mm ) * 60 );
	    if( block[i][0] == '-' ){
		zone = zone * -1;
	    }
	}
	if( strlen( block[i] ) == 4 && v > 1970 ){
	    ano = v;
	    flag_ano = 1;

	}
	if( strlen( block[i] ) == 8 && block[i][2]==':' && block[i][5]==':'  ){
	    hora    = atoi( block[i] );
	    minuto  = atoi( &block[i][3] );
	    segundo = atoi( &block[i][6] );

	    flag_hora = 1;
	    
	}	
    }
    if( flag_hora ==1 && flag_dia == 1 && flag_zone ==1 && flag_ano ){
	memset( &tm, 0x00, sizeof( struct tm ));
    
        tm.tm_sec  = segundo;
	tm.tm_min  = minuto;
	tm.tm_hour = hora;
	tm.tm_mday = dia;
	tm.tm_mon  = month->code-1;
	tm.tm_year = ano-1900;

	result = mktime( &tm ) +zone;
    } else {
	result = time(NULL);
    }

    return result;

}
int have_crlf( char * buffer, int size )
{
	int i;

	for( i=0;i< size-1 ;i++ ){
		if( buffer[i] == 0x0d && buffer[i+1]==0x0a ){
			return 1;
		}
	}
	return 0;
}

char * hash_sha1( char * data )
{
	SHA1_CTX sha1;
	unsigned char * digest;

	digest = malloc( 20 );

	SHA1Init( &sha1 );
	SHA1Update( &sha1, data, strlen(data));
	SHA1Final( digest, &sha1 );

	return digest;
}

char * string_replace( char * source, char *name, char *value, ...)
{
    int i;
    int ok = 0;
    int name_size;
    int temp01_size;
    int size;

    char *result=NULL;
    char temp01[8192];
    va_list args;

    va_start(args, value);
    vsnprintf(temp01, 8192, value, args);
    va_end(args);

    size = strlen(source);
    name_size = strlen(name);
    temp01_size = strlen(temp01);

    for (i = 0; i < size; i++) {
	if (source[i] == '[' && strncasecmp(&source[i + 1], name, name_size) == 0 && source[i + 1 + name_size] == ']') {
	    ok = 1;
	    result = malloc(size + (temp01_size - name_size - 2) + 1);
	    memcpy(result, source, i);
	    memcpy(&result[i], temp01, temp01_size);
	    memcpy(&result[i + temp01_size], &source[i + name_size + 2], size - i - 2 - name_size);


	    result[size + (temp01_size - name_size - 2) ] = 0x00;
	}
    }
    if( !result ){
    	result = malloc( size + 1 );
	memcpy( result, source, size );
	result[size]=0x00;
    }
    return result;
}
int get_word( char * buffer, int buffer_size, char * line, int line_size, int * pos, char delimiter , int count )
{
        int doit=0;
        int init=0;
        int cpos = 0;
        int i;

        count = count -1;

        for(i=*pos;i<line_size;i++){
                if( *pos==0 && count == 0){
                        doit = 1;
                        init  = 0;
                        break;
                } else if( line[i]==delimiter && count == 0  && line[i+1]!=delimiter){
                        doit=1;
                        init = i+1;
                        break;
                } else if( line[i]==delimiter && count > 0 && line[i+1]!=delimiter){
                        count--;
                }
        }
        if( doit ){
                for(i=init;i<line_size;i++){
                        if( cpos >= line_size ){
                                break;
                        }
                        if( line[i]==delimiter ){
                                break;
                        }
                        buffer[cpos++]=line[i];
                }
                buffer[cpos]=0x00;
                if( pos ){
                        *pos = i;
                }

                return 1;
       }
        if( pos ){
                *pos = i;
        }
        return 0;
}

