/***************************************************************************
    begin                : Sun Oct 05
    copyright            : (C) 2003 by Fabio Yasusi Yamamoto
    email                : fabio@hostname.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#define __USE_BSD		/* GLIBC */
#define _BSD_SOURCE		/* LIBC5 */

#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <netinet/in.h>
#include <netdb.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <sys/un.h>
#include <sys/errno.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <time.h>
#include <arpa/inet.h>

#include <netinet/in_systm.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <netinet/ip6.h>
#include <netinet/ip_icmp.h>
#include <netinet/icmp6.h>
#include <netinet/tcp.h>
#include <netinet/udp.h>


#include <openssl/ssl.h>

#include "socket.h"

#include "config_file.h"
#include "NatACL.h"
#include "webserver.h"
#include "util.h"

#include "log.h"

int main(int argc, char **argv)
{
    int sock_webserverlan_listen;
    int sock_webserverlan_ssl_listen;
    int sock_ping;
    int newfd;
    int sin_len;
    int t;
    int i;
    int on = 1;    

    struct sockaddr_in sin;
    struct in_addr in;

    struct s_queue_auth_hdr * s_user_walk;

    struct timeval tv;
    struct s_data_hdr s_data;
    struct s_connection_hdr *s_connection_walk;
    struct s_config_hdr * s_config_lan_list;
    struct s_config_hdr * s_config_temp;

    fd_set fds;

    sin_len =  sizeof( struct sockaddr_in );

    if( getuid() !=0 ){
	printf("You must be root\n");
	fflush( stdout );
	exit( 0 ) ;
    }
    memset( &s_data, 0x00, sizeof( struct s_data_hdr ));
    
    SSL_library_init();
    SSL_load_error_strings();


    if ((sock_ping = socket(AF_INET, SOCK_RAW, IPPROTO_ICMP)) < 0) {
	perror("Couldn't open RAW socket");
	return 0;
    }
    if (setsockopt(sock_ping, IPPROTO_IP, IP_HDRINCL, &on, sizeof(on)) < 0) {
	perror("Couldn't setsockopt IP_HDRINCL");
	return 0;
    }


    wlog( FILE_LOG,"[NatACL] Init" );
    sock_webserverlan_listen     = sock_bind_tcp( 5121 );
    sock_webserverlan_ssl_listen = sock_bind_tcp( 5122 );

    s_data.s_config_root = read_config_files( "/usr/local/etc/NatACL.conf" );


    if(!(s_data.s_config_lan = config_search( s_data.s_config_root, "LAN_INTERFACE" ))){
	printf("Missing [LAN_INTERFACE] in /usr/local/etc/NatACL.conf\n");
	exit  ( 0 );
    }

    s_config_lan_list = s_data.s_config_lan->root;
    while( s_config_lan_list ){
    	wlog( FILE_LOG,"[INFO] LAN ADDRESS [%s:%s]\n", s_config_lan_list->s_args->args[0], s_config_lan_list->s_args->args[1] );

	s_config_lan_list = s_config_lan_list->right;
    }

    if(!(s_data.s_config_wan = config_search( s_data.s_config_root, "WAN_INTERFACE" ))){
	printf("Missing [LAN_INTERFACE] in /usr/local/etc/NatACL.conf\n");
	exit  ( 0 );

    }
    wlog( FILE_LOG,"[INFO] WAN ADDRESS [%s:%s]\n", s_data.s_config_wan->root->s_args->args[0], s_data.s_config_wan->root->s_args->args[1]  );

    if((s_data.s_config_natd_port = config_search( s_data.s_config_root, "NATD_PORT" ))){
    	s_data.natd_port = atoi( s_data.s_config_natd_port->root->s_args->args[0] );
    }
    if((s_data.s_config_natd_port = config_search( s_data.s_config_root, "PROXY_PORT" ))){
    	s_data.proxy_port = atoi( s_data.s_config_natd_port->root->s_args->args[0] );
    }
    if((s_data.s_config_simultaneous_logon = config_search( s_data.s_config_root, "SIMULTANEOUS_LOGON" ))){
        if( s_data.s_config_natd_port->root->s_args->args[0] ){
	    if( strcmp( s_data.s_config_natd_port->root->s_args->args[0], "NO" ) == 0 ){
    		s_data.simultaneous = 0;
	    } else {
    		s_data.simultaneous = 1;	
	    }
	}
    }
    

    if(!(s_data.s_config_nat_type = config_search( s_data.s_config_root, "NAT_TYPE" ))){
	printf("Missing [NAT_TYPE] in /usr/local/etc/NatACL.conf\n");
	exit  ( 0 );
    }
    if(!(s_data.s_config_nat_rule = config_search( s_data.s_config_root, s_data.s_config_nat_type->root->s_args->args[0] ))){
	printf("Missing [%s] in /usr/local/etc/NatACL.conf\n",s_data.s_config_nat_type->root->s_args->args[0]);
	exit  ( 0 );
    }


    wlog( FILE_LOG,"[%s] Init", s_data.s_config_nat_type->root->s_args->args[0] );
    if( strcmp( s_data.s_config_nat_type->root->s_args->args[0], "IPNAT" ) == 0 ){
//    	init_ipnat( &s_data );
    } else {
    	init_nat_generic( &s_data );
    }

    printf("Starting Daemon\n");
    if((i=fork())>0)
	return 0;
    else if(i<0) {
    	exit(1);
    }
    
    while (1) {
	tv.tv_sec = 0;
	tv.tv_usec = 100000;

	FD_ZERO(&fds);
	FD_SET(sock_webserverlan_listen, &fds);
	FD_SET(sock_webserverlan_ssl_listen, &fds);
	FD_SET(sock_ping, &fds);

	if( s_data.s_fd ){
		s_connection_walk = s_data.s_fd->s_first;
		while (s_connection_walk) {
			FD_SET(s_connection_walk->fd, &fds);

			s_connection_walk = s_connection_walk->s_right;
		}
	}

	select(find_last_fd(s_data.s_fd, sock_webserverlan_ssl_listen) + 1, &fds, NULL, NULL, &tv);

	if (FD_ISSET(sock_webserverlan_listen, &fds)) {
		newfd = accept( sock_webserverlan_listen, (struct sockaddr *)&sin, &sin_len );
		if( verbose >2 ){
		    wlog( FILE_LOG,"[SOCKET] [%15s] Connection accepted", inet_ntoa( sin.sin_addr ) );
		}
		s_data.s_fd = add_queue( s_data.s_fd, newfd );
		snprintf( s_data.s_fd->s_last->source_addr, 64, "%s", inet_ntoa( sin.sin_addr ));
	}
	if (FD_ISSET(sock_webserverlan_ssl_listen, &fds)) {
		newfd = accept( sock_webserverlan_ssl_listen, (struct sockaddr *)&sin, &sin_len );
		if( verbose >2 ){
		    wlog( FILE_LOG,"[SOCKET] [%15s] Connection accepted", inet_ntoa( sin.sin_addr ) );
		}
		s_data.s_fd = add_queue( s_data.s_fd, newfd );
		snprintf( s_data.s_fd->s_last->source_addr, 64, "%s", inet_ntoa( sin.sin_addr ));

		s_data.s_fd->s_last->ssl = 1;
		if( !init_ssl( s_data.s_fd->s_last ) ){
			close( newfd );
			del_queue( s_data.s_fd, s_data.s_fd->s_last );
		}
	}
	if( s_data.s_fd ){
		s_connection_walk = s_data.s_fd->s_first;
		while (s_connection_walk) {
			if (FD_ISSET( s_connection_walk->fd, &fds)) {
				if( handle_webserver( &s_data, s_connection_walk) == 0 ){
					if( verbose >2 ){
					    wlog( FILE_LOG,"[SOCKET] [%15s] Connection closed" , s_data.s_fd->s_last->source_addr);
					}
					if( s_connection_walk->keepalive == 2 ){
					    s_user_walk = get_user_by_host( s_data.s_user_queue,inet_addr(s_connection_walk->source_addr));
					    
					    wlog( FILE_LOG,"[AUTH] [%20s] Authentication expired - POPUP", s_user_walk->name );
					    
					    del_rule( &s_data, s_user_walk->source );
					    del_queue_auth(s_data.s_user_queue, s_user_walk );
					}
					close( s_connection_walk->fd );
					sock_buf_close( s_connection_walk->s_buf );

					s_connection_walk = del_queue( s_data.s_fd, s_connection_walk );
					

				} else {
					s_connection_walk = s_connection_walk->s_right;
				}
			} else {
				s_connection_walk = s_connection_walk->s_right;
			}
		}
	}
	if (FD_ISSET( sock_ping, &fds) ) {
		handle_ping( &s_data, sock_ping );
	}
	if( s_data.s_user_queue ){
		t = time(NULL);

		s_user_walk = s_data.s_user_queue->s_first;
		while( s_user_walk ){
			switch( s_user_walk->type ){
				case TYPE_EXPIRE_TIME:
					if( t > s_user_walk->expire_tv + s_user_walk->logon_tv ){
						del_rule( &s_data, s_user_walk->source );

    	    					blog_add( FILE_BIN_LOG, FILE_BIN_IDX, s_user_walk->name, inet_addr(s_user_walk->source), ACTION_REVOKE );

						wlog( FILE_LOG,"[AUTH] [%20s] Authentication expired - TIME - %d > %d + %d", s_user_walk->name,t > s_user_walk->expire_tv + s_user_walk->logon_tv );
						s_user_walk =  del_queue_auth(s_data.s_user_queue, s_user_walk );
					} else {
						s_user_walk = s_user_walk->s_right;
					}
				break;
				case TYPE_EXPIRE_PING:
					if( t > s_user_walk->ping_tv + PING_INTERVAL ){
						if( verbose >5 ){
						    wlog( FILE_LOG,"Sending ping"  );
						}
						send_ping( &s_data, sock_ping, s_user_walk->local_address, s_user_walk->source_addr, s_user_walk->source_addr );

						s_user_walk->ping_tv = t;
					}

					if( time(NULL) - s_user_walk->ping_lt > PING_TIMEOUT ){
    	    					blog_add( FILE_BIN_LOG, FILE_BIN_IDX, s_user_walk->name, inet_addr(s_user_walk->source), ACTION_REVOKE );

						wlog( FILE_LOG,"[AUTH] [%20s] Authentication expired - PING - %d %d %d", s_user_walk->name,time(NULL) , s_user_walk->ping_lt , PING_TIMEOUT );

						del_rule( &s_data, s_user_walk->source );

						s_user_walk =  del_queue_auth(s_data.s_user_queue, s_user_walk );
					} else {
						s_user_walk = s_user_walk->s_right;
					}
				break;
				case TYPE_EXPIRE_PINGTIME:
					if( t > s_user_walk->ping_tv + PING_INTERVAL ){
						if( verbose >5 ){
						    wlog( FILE_LOG,"Sending ping- PINGTIME"  );
						}
						send_ping( &s_data, sock_ping, s_user_walk->local_address, s_user_walk->source_addr, s_user_walk->source_addr );

						s_user_walk->ping_tv = t;
					}
					
					
					if( t > s_user_walk->logon_tv + s_user_walk->expire_tv ){
						del_rule( &s_data, s_user_walk->source );

    	    					blog_add( FILE_BIN_LOG, FILE_BIN_IDX, s_user_walk->name, inet_addr(s_user_walk->source), ACTION_REVOKE );
						wlog( FILE_LOG,"[AUTH] [%20s] Authentication expired - TIME - %d > %d + %d", s_user_walk->name,t , s_user_walk->logon_tv , s_user_walk->expire_tv );
						s_user_walk =  del_queue_auth(s_data.s_user_queue, s_user_walk );
					} else	if( time(NULL) - s_user_walk->ping_lt > PING_TIMEOUT ){
						wlog( FILE_LOG,"[AUTH] [%20s] Authentication expired - PING - %d %d %d", s_user_walk->name,time(NULL) , s_user_walk->ping_lt , PING_TIMEOUT );

    	    					blog_add( FILE_BIN_LOG, FILE_BIN_IDX, s_user_walk->name, inet_addr(s_user_walk->source), ACTION_REVOKE );
						del_rule( &s_data, s_user_walk->source );

						s_user_walk =  del_queue_auth(s_data.s_user_queue, s_user_walk );
					} else {
						s_user_walk = s_user_walk->s_right;
					}
				break;
				case TYPE_EXPIRE_POPUP:
					s_user_walk = s_user_walk->s_right;
				break;
				default:
					wlog( FILE_LOG,"[ERROR] [EXPIRE] [%20s] Invalid expire method", s_user_walk->name );

					s_user_walk = s_user_walk->s_right;
				break;
			}
		}
	}
   }
}

int handle_ping( struct s_data_hdr * s_data, int sock )
{
	int sinlen;
	char packet[1500];

        unsigned long *t;

	struct s_queue_auth_hdr *s_auth_walk;

	struct ip   * s_ip;
	struct icmp * s_icmp;



	sinlen = sizeof(struct sockaddr);

	s_ip   = (struct ip    *) &packet;
	s_icmp = (struct icmp  *) &packet[sizeof(struct ip)];
	t      = (unsigned long *) &packet[sizeof(struct ip) + sizeof(struct icmp)];

	recvfrom( sock, packet, 1500, 0, NULL, &sinlen );

	if( !s_data->s_user_queue ){
		return 0;
	}

	if (s_ip->ip_p == IPPROTO_ICMP) {
		s_auth_walk = s_data->s_user_queue->s_first;
		while (s_auth_walk) {
			if (s_icmp->icmp_id == htons( 3000 ) && s_icmp->icmp_seq == 1 && *t == htonl( s_auth_walk->source_addr )) {
				s_auth_walk->ping_lt = time(NULL);
				if( verbose >2 ){
				    wlog( FILE_LOG,"[NatACL] PING ANSWER RECEIVED [%s]",s_auth_walk->name );
				}
				break;
			}
			s_auth_walk = s_auth_walk->s_right;
		}
	}
}
int send_ping( struct s_data_hdr * s_data, int sock, unsigned long source, unsigned long host, unsigned long id )
{
	char packet[1500];
	int  sinlen = sizeof(struct sockaddr);

	unsigned long * t;
	struct ip *s_ip;
	struct icmp *s_icmp;
	struct sockaddr_in sin;

	s_ip   = (struct ip    *) &packet;
	s_icmp = (struct icmp  *) &packet[sizeof(struct ip)];
	t      = (unsigned long *) &packet[sizeof(struct ip) + sizeof(struct icmp)];

	memset(packet, 0x00, 1500);

	sin.sin_addr.s_addr = host;
	sin.sin_port        = 0;
	sin.sin_family      = AF_INET;

	s_ip->ip_src.s_addr = source;
	s_ip->ip_dst.s_addr = host;

	s_ip->ip_v   = 4;
	s_ip->ip_hl  = sizeof(struct ip) >> 2;
	s_ip->ip_len = sizeof(struct ip) + sizeof(struct icmp) + 4;
	s_ip->ip_id  = 3000;
	s_ip->ip_off = 0;
	s_ip->ip_tos = 0;
	s_ip->ip_ttl = 255;
	s_ip->ip_p   = IPPROTO_ICMP;
	s_ip->ip_sum = 0;

	s_icmp->icmp_type  = ICMP_ECHO;
	s_icmp->icmp_code  = 0;
	s_icmp->icmp_cksum = 0;
	s_icmp->icmp_seq   = 1;
	s_icmp->icmp_id    = htons( 3000 );

	*t = htonl( id );

	s_icmp->icmp_cksum = in_cksum((u_short *) s_icmp, sizeof( struct icmp ) + 4 );

	if (sendto(sock, packet, sizeof(struct ip) + sizeof(struct icmp) + 4, 0, (struct sockaddr *) &sin, sizeof(struct sockaddr)) <= 0) {
		perror("sendto");
	}

	return 1;
}

int find_last_fd(struct s_connection *s_fd, int sock1)
{
	int fd;
	struct s_connection_hdr *s_connection_walk;

	fd = sock1;

	if( s_fd ){
		s_connection_walk = s_fd->s_first;
		while (s_connection_walk) {
			if (s_connection_walk->fd > fd) {
				fd = s_connection_walk->fd;
			}
			s_connection_walk = s_connection_walk->s_right;
		}
	}
	return fd;
}
struct s_connection * add_queue( struct s_connection * s_q, int fd )
{
	struct s_connection_hdr * s_fd;

	if( !s_q ){
		s_q = ( struct s_connection * )calloc( 1, sizeof( struct s_connection ) );
	}
	s_fd = ( struct s_connection_hdr * )calloc( 1, sizeof( struct s_connection_hdr ) );

	if( !s_q->s_first ){
		s_q->s_first = s_fd;
	} else {
		s_fd->s_right     = NULL;
		s_fd->s_left      = s_q->s_last;
		s_q->s_last->s_right   = s_fd;
	}
	s_q->s_last = s_fd;

	s_fd->fd = fd;

	return s_q;
}
struct s_connection_hdr * del_queue( struct s_connection * s_q, struct s_connection_hdr * s_fd )
{
    struct s_connection_hdr * s_tmp;

    s_tmp = s_fd->s_right;

    if( s_q->s_last == s_fd )
	s_q->s_last = s_fd->s_left;

    if( s_q->s_first == s_fd )
	s_q->s_first = s_fd->s_right;

    if( s_fd->s_left ){
    	s_fd->s_left->s_right = s_fd->s_right;
    }
    if( s_fd->s_right ){
    	s_fd->s_right->s_left = s_fd->s_left;
    }
    free( s_fd );

    return s_tmp;
}

int add_rule( struct s_data_hdr * s_data, char * source_address )
{
	char buffer[255];

	struct s_config_hdr * s_config_lan_list;
	struct s_config_hdr * s_config_list;
	char * new_line;


	s_config_lan_list = s_data->s_config_lan->root;
	while( s_config_lan_list ){
		wlog( FILE_LOG,"[GRANT] Added granted rule to [%s]" , source_address );

		s_config_list = s_data->s_config_nat_rule->root;
		while( s_config_list ){
			if( strcmp( s_config_list->s_args->args[0], "GRANT" ) == 0 ){
				if((new_line = process_config_line( s_config_list->s_args->args[1], s_config_lan_list->s_args->args[0], source_address, s_data->s_config_wan->root->s_args->args[1],  s_data->s_config_wan->root->s_args->args[0],NULL, s_data->natd_port, s_data->proxy_port ))){
				    if( verbose >2 ){
					wlog( FILE_LOG,"[%s] %s", s_data->s_config_nat_type->root->s_args->args[0], new_line );
				    }
				    system  ( new_line );

				    free( new_line );
				}
			}
			s_config_list = s_config_list->right;
		}
		s_config_lan_list = s_config_lan_list->right;
	}
}
int del_rule( struct s_data_hdr * s_data, char * source_address )
{
	char buffer[255];

	struct s_config_hdr * s_config_lan_list;
	struct s_config_hdr * s_config_list;
	char * new_line;



	s_config_lan_list = s_data->s_config_lan->root;
	while( s_config_lan_list ){
		wlog( FILE_LOG,"[REVOKE] remove granted rule to [%s]" , source_address );

		s_config_list = s_data->s_config_nat_rule->root;
		while( s_config_list ){
			if( strcmp( s_config_list->s_args->args[0], "REVOKE" ) == 0 ){
				if((new_line = process_config_line( s_config_list->s_args->args[1], s_config_lan_list->s_args->args[0], source_address, s_data->s_config_wan->root->s_args->args[1],  s_data->s_config_wan->root->s_args->args[0],NULL, s_data->natd_port, s_data->proxy_port ))){
				    if( verbose >2 ){
					wlog( FILE_LOG,"[%s] %s", s_data->s_config_nat_type->root->s_args->args[0], new_line );
				    }
				    system  ( new_line );
	
				    free( new_line );
				    
				}
			}
			s_config_list = s_config_list->right;
		}
		s_config_lan_list = s_config_lan_list->right;
	}

}
char * check_address( struct s_data_hdr * s_data, unsigned long address )
{
	char * result = NULL;

	int init,end,i;
	struct s_config_hdr * s_config_lan_list;
	struct in_addr        in;

	char netmask[10];
	char network[64];
	unsigned long i_network;

	s_config_lan_list = s_data->s_config_lan->root;
	while( s_config_lan_list ){
		snprintf( netmask , 64, "%s", strchr( s_config_lan_list->s_args->args[1],'/'  ) + 1);
		snprintf( network , 64, "%s", s_config_lan_list->s_args->args[1] );

		for( i=0;i<strlen( network );i++ ){
			if( network[i]=='/' ){
				network[i]=0x00;
			}
		}
		i_network= inet_addr(network );

		init = i_network & ( unsigned long )(( 1<<(atoi(netmask))) -1 );
		end  = i_network | ( unsigned long )( 0- (1<<(atoi(netmask))));

		if( ntohl( address ) >= ntohl( init ) && ntohl( address ) <= ntohl( end )){
			result = s_config_lan_list->s_args->args[0];

			break;
		}
		s_config_lan_list = s_config_lan_list->right;
	}
	return result;
}

int check_user_logged( struct s_queue_auth * s_q, char * user )
{
    struct s_queue_auth_hdr * s_fd;
    
    if( !s_q) {
	return 0;
    }
    
    s_fd = s_q->s_first;
    while( s_fd ){
	if( strcmp( s_fd->name, user ) == 0 ){
	    return 1;
	}
	s_fd = s_fd->s_right;
    }    
    return 0;
}
struct s_queue_auth_hdr * get_user_by_host( struct s_queue_auth * s_q, unsigned long addr )
{
    struct s_queue_auth_hdr * s_fd;
    
    if( !s_q) {
	return NULL;
    }
    
    s_fd = s_q->s_first;
    while( s_fd ){
	if( s_fd->source_addr== addr ){
	    return s_fd;
	}
	s_fd = s_fd->s_right;
    }    
    return NULL;
}
struct s_queue_auth  * add_queue_auth( struct s_queue_auth  * s_q, char * name, int tv, int type, int lt, unsigned long source_address, unsigned long local_address )
{
	struct in_addr in;
	struct s_queue_auth_hdr * s_fd;

	if( !s_q ){
		s_q = ( struct s_queue_auth  * )calloc( 1, sizeof( struct s_queue_auth  ) );
	}
	s_fd = ( struct s_queue_auth_hdr * )calloc( 1, sizeof( struct s_queue_auth_hdr ) );

	if( !s_q->s_first ){
		s_q->s_first = s_fd;
	} else {
		s_fd->s_right     = NULL;
		s_fd->s_left      = s_q->s_last;
		s_q->s_last->s_right   = s_fd;
	}
	s_q->s_last = s_fd;

	snprintf( s_fd->name, 64, "%s", name );

	s_fd->logon_tv   = tv;
	s_fd->expire_tv  = lt;
	s_fd->type = type;
	s_fd->local_address = local_address;
	s_fd->ping_lt = time(NULL);

	s_fd->source_addr= source_address;

	in.s_addr = source_address;
	snprintf( s_fd->source, 20, "%s", inet_ntoa( in ));




	return s_q;
}
struct s_queue_auth_hdr * del_queue_auth( struct s_queue_auth * s_q, struct s_queue_auth_hdr * s_fd )
{
    struct s_queue_auth_hdr * s_tmp;

    s_tmp = s_fd->s_right;

    if( s_q->s_last == s_fd )
	s_q->s_last = s_fd->s_left;

    if( s_q->s_first == s_fd )
	s_q->s_first = s_fd->s_right;

    if( s_fd->s_left ){
    	s_fd->s_left->s_right = s_fd->s_right;
    }
    if( s_fd->s_right ){
    	s_fd->s_right->s_left = s_fd->s_left;
    }
    free( s_fd );

    return s_tmp;
}

char * process_config_line( char * line, char * interface, char * client_address, char * wan_address, char * wan_interface, char * lan_interface, int natd_port, int proxy_port )
{
	char * result1 = NULL;
	char * result2 = NULL;

	result1 = string_replace( line, "CLIENT_ADDRESS", "%s", client_address );

	result2 = string_replace( result1, "INTERFACE", "%s", interface );
	free( result1 );

	result1 = string_replace( result2, "WAN_ADDRESS", "%s", wan_address );
	free( result2 );

	result2 = string_replace( result1, "LAN_INTERFACE", "%s", lan_interface );
	free( result1 );

	result1 = string_replace( result2, "WAN_INTERFACE", "%s", wan_interface );
	free( result2 );

	result2 = string_replace( result1, "NATD_PORT", "%d",  natd_port );
	free( result1 );

	result1 = string_replace( result2, "PROXY_PORT", "%d",  proxy_port );
	free( result2 );

	return result1;
}

int init_nat_generic( struct s_data_hdr * s_data )
{
	struct s_config_hdr * s_config_lan_list;
	struct s_config_hdr * s_config_list;
	char buffer[255];
	char * new_line;

	s_config_lan_list = s_data->s_config_lan->root;

	wlog( FILE_LOG,"[%s] Added interface [%s]" , s_data->s_config_nat_type->root->s_args->args[0],s_config_lan_list->s_args->args[0] );

	s_config_list = s_data->s_config_nat_rule->root;
	while( s_config_list ){
		if( strcmp( s_config_list->s_args->args[0], "START" ) == 0 ){
			if((new_line = process_config_line( s_config_list->s_args->args[1], s_config_lan_list->s_args->args[0], NULL,  s_data->s_config_wan->root->s_args->args[1],  s_data->s_config_wan->root->s_args->args[0],s_config_lan_list->s_args->args[1],s_data->natd_port, s_data->proxy_port ))){
				wlog( FILE_LOG,"[%s] %s", s_data->s_config_nat_type->root->s_args->args[0], new_line );
				system  ( new_line );

				free( new_line );
			}
		}
		s_config_list = s_config_list->right;
	}



	s_config_lan_list = s_data->s_config_lan->root;
	while( s_config_lan_list ){
		wlog( FILE_LOG,"[%s] Added interface [%s]" , s_data->s_config_nat_type->root->s_args->args[0],s_config_lan_list->s_args->args[0] );

		s_config_list = s_data->s_config_nat_rule->root;
		while( s_config_list ){
			if( strcmp( s_config_list->s_args->args[0], "INIT" ) == 0 ){
				if((new_line = process_config_line( s_config_list->s_args->args[1], s_config_lan_list->s_args->args[0], NULL,  s_data->s_config_wan->root->s_args->args[1],  s_data->s_config_wan->root->s_args->args[0],s_config_lan_list->s_args->args[1],s_data->natd_port, s_data->proxy_port ))){
					wlog( FILE_LOG,"[%s] %s", s_data->s_config_nat_type->root->s_args->args[0], new_line );
					system  ( new_line );

					free( new_line );
				}
			}
			s_config_list = s_config_list->right;
		}
		s_config_lan_list = s_config_lan_list->right;
	}



}


int init_ssl( struct s_connection_hdr * s_connection )
{
	if(!( s_connection->ssl_client_ctx = SSL_CTX_new(SSLv23_server_method()))){
		wlog( FILE_LOG, "[ERROR] [SSL] SSL_CTX_new" );
		return 0;
	}

	if( SSL_CTX_use_certificate_file( s_connection->ssl_client_ctx, CERT_FILE, SSL_FILETYPE_PEM ) <=0 ){
		wlog( FILE_LOG, "[ERROR] [SSL] SSL_CTX_use_certificate_file" );
		return 0;
	}

	if( SSL_CTX_use_PrivateKey_file ( s_connection->ssl_client_ctx, CERT_FILE, SSL_FILETYPE_PEM ) <=0 ){
		wlog( FILE_LOG, "[ERROR] [SSL] SSL_CTX_use_PrivateKey_file" );
		return 0;
	}
	if( SSL_CTX_check_private_key   ( s_connection->ssl_client_ctx ) <=0 ){
		wlog( FILE_LOG, "[ERROR] [SSL] SSL_CTX_check_private" );
		return 0;
	}

	if(!( s_connection->ssl_client = SSL_new( s_connection->ssl_client_ctx ))){
		wlog( FILE_LOG, "[ERROR] [SSL] SSL_new" );
		return 0;
	}


	if( SSL_set_fd( s_connection->ssl_client, s_connection->fd ) <=0 ){
		wlog( FILE_LOG, "[ERROR] [SSL] SSL_set_fd" );
		return 0;
	}

	if( SSL_accept( s_connection->ssl_client ) <=0 ){
		return 0;
	}

	return 1;
}
