#define TYPE_EXPIRE_PING    	0x01
#define TYPE_EXPIRE_TIME    	0x02
#define TYPE_EXPIRE_TRAFFIC 	0x03 /* TODO */
#define TYPE_EXPIRE_POPUP   	0x04 /* TODO */
#define TYPE_EXPIRE_PINGTIME   	0x05


#define FILE_LOG "/var/log/NatACL/NatACL.log"
#define FILE_BIN_LOG "/var/log/NatACL"
#define FILE_BIN_IDX "/var/log/NatACL"

#define CERT_FILE "/var/NatACL/cert_server.pem"
#define HAVE_SSL

#define PING_INTERVAL 10
#define PING_TIMEOUT  30

struct s_queue_auth_hdr {
	char name[64];
//	int tv;
	int keepalive;
	int lt;
	int type;
	unsigned long source_addr;
	char source[64];
	unsigned long local_address;
	unsigned long ping_lt;
	unsigned long ping_tv;
	unsigned long ping_id;
	unsigned long expire_tv;
	unsigned long logon_tv;

	struct s_queue_auth_hdr * s_right;
	struct s_queue_auth_hdr * s_left;
};
struct s_queue_auth {
	struct s_queue_auth_hdr * s_first;
	struct s_queue_auth_hdr * s_last;
};

struct s_connection_hdr {
	int fd;
	int ssl;
	int keepalive;
	char source_addr[64];

	struct s_buf_hdr * s_buf;
	struct s_http_hdr * s_http;

	SSL         *ssl_client;
	SSL_CTX     *ssl_client_ctx;

	struct s_connection_hdr * s_right;
	struct s_connection_hdr * s_left;
};
struct s_connection {
	struct s_connection_hdr * s_first;
	struct s_connection_hdr * s_last;
};

struct s_data_hdr {
	struct s_queue_auth * s_user_queue;
	struct s_connection * s_fd;

	struct s_config_hdr * s_config_root;
	struct s_config_hdr * s_config_lan;
	struct s_config_hdr * s_config_wan;
	struct s_config_hdr * s_config_nat_type;
	struct s_config_hdr * s_config_nat_rule;
	struct s_config_hdr * s_config_natd_port;
	struct s_config_hdr * s_config_simultaneous_logon;
	
	int simultaneous;

	int natd_port;
	int proxy_port;
};

struct s_queue_auth_hdr * del_queue_auth( struct s_queue_auth * s_q, struct s_queue_auth_hdr * s_fd );
int find_last_fd( struct s_connection * s_fd, int sock1 );
struct s_connection * add_queue( struct s_connection * s_q, int fd );
struct s_connection_hdr * del_queue( struct s_connection * s_q, struct s_connection_hdr * s_fd );
struct s_queue_auth  * add_queue_auth( struct s_queue_auth  * s_q, char * name, int tv, int type, int lt, unsigned long source_address, unsigned long local_address );
int add_rule( struct s_data_hdr * s_data, char * source_address );
char * check_address( struct s_data_hdr * s_data, unsigned long address );

char * process_config_line( char * line, char * interface, char * client_address, char * wan_address, char * wan_interface, char * lan_interface, int natd_port, int proxy_port );
int init_ssl( struct s_connection_hdr * s_connection );

int verbose;

struct s_queue_auth_hdr * get_user_by_host( struct s_queue_auth * s_q, unsigned long addr );

