/***************************************************************************
    begin                : Sun Oct 05
    copyright            : (C) 2003 by Fabio Yasusi Yamamoto
    email                : fabio@hostname.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <dirent.h>
#include <dlfcn.h>
#include <stdarg.h>

#include <openssl/ssl.h>

#include "NatACL.h"
#include "auth.h"

struct s_user_hdr * auth_vrfy( struct s_data_hdr * s_data, char * login, char * password, char * address )
{
	struct s_user_hdr * s_user = NULL;
	struct dirent *sDirent;
	int logged  =0;
	int process =0;
	DIR *sDir;


	logged = check_user_logged( s_data->s_user_queue, login );
	
	if( logged ){
	    if( s_data->simultaneous ){
		process = 1;
	    }	
	} else {
	    process = 1;
	}
	if( process ){
	    if ((sDir = opendir("/var/NatACL/modules/auth"))) {
	    	    while ((sDirent = readdir(sDir))) {
			    if( strlen( sDirent->d_name ) > 3 ){
    		    		if (strcmp(sDirent->d_name, ".") && strcmp(sDirent->d_name, "..") && strncmp(&sDirent->d_name[strlen(sDirent->d_name) - 5], ".lock", 5) ) {
					if((s_user = run_auth_module( s_data, sDirent->d_name, login, password, address ))){
					    wlog( FILE_LOG,"[AUTH] [%15s] [%15s] User Logged", address, login );

					    break;
				        }
    				}
			    }
		    }
	    }
	}
	if( s_user == NULL ){
		wlog( FILE_LOG,"[AUTH] [%15s] [%15s] Invalid Password", address, login );
	}
	return s_user;


}
struct s_user_hdr * run_auth_module( struct s_data_hdr * s_data, char * fname, char * login, char *password, char * ip )
{
	void * module;
	char filename[255];
	const char * error;
	struct s_user_hdr * s_user;

	snprintf( filename, 255, "/var/NatACL/modules/auth/%s", fname );

	if(( module = dlopen( filename, RTLD_LAZY ))==NULL){
		fprintf(stderr, "Couldn't open module: %s\n",dlerror());
	}
	run_module = dlsym( module, "run_module" );

    	if (( error = dlerror()) ) {
        	fprintf( stderr, "Couldn't find module: %s\n", error );
        	exit   ( 1 );
    	}

	s_user = run_module( s_data, login, password, ip );

	dlclose( module );

	return s_user;
}
