/***************************************************************************
    begin                : Thu Oct 22
    copyright            : (C) 2002 by Fabio Yasusi Yamamoto
    email                : fabio@hostname.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <netinet/in.h>
#include <netdb.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <sys/un.h>
#include <sys/errno.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <signal.h>
#include <pthread.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/mman.h>
#include <pcap.h>

#include <openssl/ssl.h>

#include "file.h"

#include "config_file.h"

struct s_config_hdr *config_add(struct s_config_hdr *root, struct s_config_hdr * last, struct s_parse_args * s_args )
{
    int v;
    struct s_config_hdr *s_pointer;

    struct s_config_hdr *New;

    s_pointer = root;

    if( !s_args ){
	return root;
    }
    if (!root) {
	New = (struct s_config_hdr *) malloc(sizeof(struct s_config_hdr));
	memset(New, 0x00, sizeof(struct s_config_hdr));

	New->s_args = s_args;
	return New;
    }

    New = (struct s_config_hdr *) malloc(sizeof(struct s_config_hdr));
    memset(New, 0x00, sizeof(struct s_config_hdr));
	
    New->s_args = s_args;

    New->right = NULL;
    New->left  = last;
    last->right = New;
    
    return New;
}
struct s_config_hdr *config_index_add(struct s_config_hdr *root, char * key )
{
    int v;
    struct s_config_hdr *s_pointer;

    struct s_config_hdr *New;

    s_pointer = root;

    if( !key ){
	return root;
    }
    if (!s_pointer) {
    
	New = (struct s_config_hdr *) malloc(sizeof(struct s_config_hdr));
	memset(New, 0x00, sizeof(struct s_config_hdr));
	New->left = NULL;
	New->right = NULL;
	New->father = NULL;

	New->key = key;

	return New;
    }
    while (s_pointer) {
	v = strcmp(key, s_pointer->key);

	if (v == 0) {
	
	    return root;
	} else if (v > 0) {
	    if (s_pointer->right) {
		s_pointer = s_pointer->right;
	    } else {		/* Nao tem nada, grave aqui */	    
		New = (struct s_config_hdr *) malloc(sizeof(struct s_config_hdr));
		memset(New, 0x00, sizeof(struct s_config_hdr));

		s_pointer->right = New;
		New->left        = NULL;
		New->right       = NULL;

		New->key         = key;

		return root;
	    }
	} else if (v < 0) {
	    if (s_pointer->left) {
		s_pointer = s_pointer->left;
	    } else {		/* Nao tem nada, grave aqui */
		New = (struct s_config_hdr *) malloc(sizeof(struct s_config_hdr));
		memset(New, 0x00, sizeof(struct s_config_hdr));

		s_pointer->left  = New;
		New->left        = NULL;
		New->right       = NULL;

		New->key         = key;

		return root;
	    }
	}
    }
    return NULL;
}
struct s_config_hdr * config_search( struct s_config_hdr * root, char * key )
{
    int v;
    struct s_config_hdr * s_pointer;


    if( !root ){
	return NULL;
    }

    s_pointer = root;    
    while( s_pointer ){
	v = strcmp( key, s_pointer->key );
	
	if( v == 0 ){
	    return s_pointer;
	}
	else if( v > 0 ){
	    if( s_pointer->right ){
		s_pointer = s_pointer->right;	
	    } else {
		return NULL;
	    }
	}
	else if( v < 0 ){
	    if( s_pointer->left ){
		s_pointer = s_pointer->left;	
	    } else {
	    
		return NULL;
	    }
	}
    }
    
    return NULL;
}
struct s_parse_args * parse_args( char * line, int line_size )
{
    int i;
    int start=0;
    int end=0;
    int count=0;
    int key=0;
    int aspas=0;
    struct s_parse_args * s_parse;

    if( !line ){
	return NULL;
    }
    if( line[0]=='#' ){
	return NULL;
    }
    s_parse = ( struct s_parse_args * )malloc( sizeof( struct s_parse_args ));

    memset( s_parse, 0x00, sizeof( struct s_parse_args ));

    for(i=0;i<line_size;i++){
	if( line[i]==' ' || line[i]==':' || line[i]==0x09 ){
	    if(!(s_parse->key = ( char * )malloc( i + 1 ))){
		exit( 0 );
	    }
	    memcpy( s_parse->key, line,i );
	    s_parse->key[i]=0x00;
	    s_parse->key_size = i;
	    key = 1;
	    break;
	}
    }
    if( !key ){
	free( s_parse );
	return NULL;
    }
    start = 0;
    end   = 0;
    aspas = 0;
    for(i=i;i<line_size;i++){
	if( line[i]=='"'  && start == 0 ){
	    start = i+1;
	    aspas = 1;
	}
	else if( line[i]=='"'  && aspas == 1){
	   end = i-1;
	}

	if( (line[i]!=' ' && line[i]!=':' && line[i]!=0x09) && start == 0 && aspas==0 ){
	    start = i;
	}
	if( ( line[i]==' ' || line[i]==':' || line[i]==0x09) && start && aspas == 0){
	    end = i;
	}

	if( i == line_size -1 && !aspas){
	    end = line_size;
	}
	if( i == line_size -1 && aspas){
	    end = line_size-1;
	}
	if( start && end ){
	    s_parse->args[s_parse->count] = malloc(  end -start + 1 );
	    memcpy( s_parse->args[s_parse->count],  &line[start], end-start );
	    s_parse->args[s_parse->count][end-start]=0x00;
	    s_parse->args_size[s_parse->count]= end-start;
	    s_parse->count++;


	    start = 0;
	    end   = 0;
	    aspas = 0;
	}
    }
    return s_parse;
}
struct s_config_hdr * read_config_files( char * filename )
{
    int i;
    int fd;
    int pos=0;
    char * map;
    char * line;

    int line_size;
    unsigned long file_size;

    struct s_parse_args * args;
    struct s_config_hdr * s_config = NULL;
    struct s_config_hdr * s_config_temp = NULL;
    struct s_config_hdr * s_config_search = NULL;

    
    if( filename ){
    
        if ((file_size = get_file_size( filename )) < 0) {
	    return 0;
	}
	if ((fd = open(filename, O_RDONLY)) <= 0) {
    	    perror(filename);
    	    return 0;
	}
	if (!(map = mmap(0, file_size, PROT_READ, MAP_SHARED, fd, 0))) {
    	    return 0;
	}
	s_config = NULL;
	while (pos < file_size) {
	    if ((line = sreadline( map, file_size, 255, &pos, &line_size,NULL))) {
		if(( args = parse_args( line, line_size ))){
		    s_config = config_index_add( s_config, args->key );
		    if(!(s_config_search = config_search( s_config, args->key ))){
			exit( 0 );
		    }
		    if( !s_config_search->root ){
			s_config_search->root = config_add( NULL, NULL, args );
			s_config_search->last = s_config_search->root;
		    } else {
			s_config_search->last = config_add( s_config_search->root, s_config_search->last, args );
		    }

		}
		free( line );
    	    }
	}
    }
    close( fd );
    munmap( map, file_size );

    return s_config;
}
