/***************************************************************************
    begin                : Thu Oct 22
    copyright            : (C) 2002 by Fabio Yasusi Yamamoto
    email                : fabio@hostname.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <fcntl.h>
#include <sys/mman.h>

#include <time.h>
#include <sys/stat.h>


void wlog( char *filename, char *msg01, ... )
{
    char 	temp01[512];
    char        tmp[255];
    FILE * fp;

    struct 	tm 	*tm;
    time_t 	t;
    va_list	args;


    if(( fp = fopen( filename,"a+" ))==NULL){
      perror( filename );
      return ;
    }

    va_start	( args, msg01 );
    vsnprintf	( temp01,512, msg01, args );
    va_end	( args );

    time	( &t );

    tm = localtime(&t);
    
    strftime(tmp, 255, "[%a %b %d %H:%M:%S]", tm );

    fprintf( fp, "%s %s\n",tmp,temp01 );
    fflush ( fp );
    fclose ( fp );
}
void wlog_fd( int fd, char *msg01, ... )
{
    char 	temp01[512];
    char        tmp[255];
    FILE * fp;

    struct 	tm 	*tm;
    time_t 	t;
    va_list	args;

    
    va_start	( args, msg01 );
    vsnprintf	( temp01,512, msg01, args );
    va_end	( args );

    time	( &t );

    tm = localtime(&t);

    strftime(tmp, 255, "[%a %b %d %H:%M:%S]", tm );

    write( fd, tmp, strlen( tmp ));
    write( fd, " " , 1 );
    write( fd, temp01, strlen( temp01 ));
    write( fd, "\n" , 1 );
}
int get_file_size(char *filename)
{
    struct stat st;

    if (stat(filename, (struct stat *) &st) != 0) {
	return -1;
    }
    return st.st_size;
}

char *file_content(char *filename)
{
    int size;
    char *result;
    FILE *fp;

    size = get_file_size(filename);

    result = malloc(size + 1);


    if ((fp = fopen(filename, "r")) == NULL) {
	perror(filename);
	exit(0);
    }
    fread(result, 1, size, fp);
    result[size] = 0x00;
    fclose(fp);

    return result;
}
