/***************************************************************************
    begin                : Sun Oct 05
    copyright            : (C) 2003 by Fabio Yasusi Yamamoto
    email                : fabio@hostname.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <stdarg.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <netinet/in.h>
#include <netdb.h>
#include <errno.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <time.h>
#include <sys/un.h>
#include <sys/errno.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <time.h>
#include <arpa/inet.h>

#include "http.h"

struct s_http_hdr * http_decode_line( struct s_http_hdr * s_http, char * line )
{
    int s = 0 ;
    int i;
    int line_size;
    int pos=0;

    if( ! line ){
	return NULL;
    }

    if( !s_http ){
	s_http = calloc( 1, sizeof( struct s_http_hdr ) );
	s_http->line = 0;
    }
    if((line_size = strlen( line ))==0){
	s_http->status = 1;
        s_http->line++;
	return s_http;
    }
    if( !s_http->line ){
	if( strncasecmp( line, "GET", 3 ) == 0 ){
	    s_http->method = METHOD_GET;
	    for( i=4;i<line_size;i++ ){
		if( pos==128 ){
		    break;
		}
		if( line[i]!=' ' && s == 0 ){
		    s = 1;
		}
		if( line[i]==' ' && s == 1 ){
		    break;
		}
		if( s ){
		    s_http->url[pos++]=line[i];
		}
	    }
	}
	else if( strncasecmp( line, "POST", 4 ) == 0 ){
	    s_http->method = METHOD_POST;
	    for( i=5;i<line_size;i++ ){
		if( pos==128 ){
		    break;
		}
		if( line[i]!=' ' && s == 0 ){
		    s = 1;
		}
		if( line[i]==' ' && s == 1 ){
		    break;
		}
		if( s ){
		    s_http->url[pos++]=line[i];
		}
	    }
	} else {
	    s_http->status = 2;
	    s_http->line++;
	    return s_http;
	}
    }
    else if( strncasecmp( line, "Host:", 5 ) == 0 ){

	strncpy( s_http->host, &line[6], 128 );
    }
    else if( strncasecmp( line, "Content-Type:", 13 ) == 0 ){
	strncpy( s_http->content_type, &line[14], 128 );
    }
    else if( strncasecmp( line, "Referer:", 8 ) == 0 ){
	strncpy( s_http->referer, &line[9], 128 );
    }
    else if( strncasecmp( line, "Content-Length:", 15 ) == 0 ){
	s_http->content_length = atoi( &line[15] );

        if( s_http->method == METHOD_POST && ( s_http->content_length <= 0 || s_http->content_length >1024 )){
	    s_http->method         = METHOD_GET;
	    s_http->content_length = 0;
	}
    }

    s_http->line++;

    return s_http;
}
char *http_parse_get(char *query, int query_size, char *name)
{
    int i = 0;
    int a = 0;
    int inicio = 0;
    int fim = 0;
    int name_size = 0;
    int status = 0;
    int opt = 1;

    char *result = NULL;
    char *r;

    name_size = strlen(name);
    status = 0;
    for (i = 0; i < query_size; i++) {
	if (query[i] == '&' || query[i] == '?' || i == 0) {
	    opt = 1;
	    if (i == 0) {
		opt = 0;
	    }
	    i = i + opt;

	    status = 1;
	    for (a = 0; a < name_size; a++) {
		if (query[i + a] != name[a]) {
		    status = 0;
		    break;
		}
	    }
	    if (status) {
		inicio = i + name_size + 1;
		fim = 0;
		for (a = inicio; a < query_size; a++) {
		    if (query[a] == '&') {
			fim = a;
			break;
		    }
		}
		if (!fim) {
		    fim = query_size;
		}
		if (!(result = malloc(fim - inicio + 1))) {
		    perror("malloc");
		    exit(0);
		}
		memcpy(result, &query[inicio], fim - inicio);
		result[fim - inicio] = 0x00;
		if (fim - inicio == 0) {
		    free(result);
		    return NULL;
		}

		break;
	    }
	}
    }
    r = http_translation( result );

    free( result );
    return r;
}
char *http_translation(char *data)
{
    int i, a;
    int size;
    int c;
    char *result = NULL;

    if (!data) {
	return NULL;
    }
    size = strlen(data);
    if (!(result = malloc(size + 1))) {
	perror(" malloc ");
	exit(0);
    }

    a = 0;
    for (i = 0; i <= size; i++) {
	if (data[i] == '%' && i + 2 <= size) {
	    sscanf(&data[i + 1], "%2x", &c);
	    result[a++] = c;
	    i = i + 2;
	} else if (data[i] == '+') {
	    result[a++] = ' ';
	} else {
	    result[a++] = data[i];
	}
    }
    if (!(result = realloc(result, a))) {
	perror(" realloc ");
	exit(0);
    }
    memcpy(data, result, a - 1);
    result[a - 1] = 0x00;
    return result;
}
