/***************************************************************************
    begin                : Thu Oct 22
    copyright            : (C) 2002 by Fabio Yasusi Yamamoto
    email                : fabio@hostname.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#define __USE_BSD		/* GLIBC */
#define _BSD_SOURCE		/* LIBC5 */
#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>
#include <netinet/in_systm.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <netinet/ip6.h>
#include <netinet/ip_icmp.h>
#include <netinet/icmp6.h>
#include <netinet/tcp.h>
#include <netinet/udp.h>
#include <arpa/inet.h>
#include <rpc/types.h>
#include <string.h>
#include <unistd.h>
#include <ctype.h>
#include <stdlib.h>


u_short in_cksum(addr, len)
u_short *addr;
int len;
{
    int nleft, sum;
    u_short *w;
    union {
	u_short us;
	u_char uc[2];
    } last;
    u_short answer;

    nleft = len;
    sum = 0;
    w = addr;

    while (nleft > 1) {
	sum += *w++;
	nleft -= 2;
    }

    if (nleft == 1) {
	last.uc[0] = *(u_char *) w;
	last.uc[1] = 0;
	sum += last.us;
    }

    sum = (sum >> 16) + (sum & 0xffff);	
    sum += (sum >> 16);		
    answer = ~sum;	
    return (answer);
}


float ping(char *source, char *host)
{
    int sock_raw;
    int on = 1;
    char packet[1500];
    int sinlen = sizeof(struct sockaddr);
    float result=0;
    int timeout=0;
    unsigned long end;
    unsigned long start;

    struct timeval tv;
    struct timeval bench;
    struct timeval now;

    struct ip *s_ip;
    struct ip *s_ip2;
    struct icmp *s_icmp;
    struct icmp *s_icmp2;
    struct sockaddr_in sin;
    int ti;

    unsigned long *t;

    fd_set fds;

    if ((sock_raw = socket(AF_INET, SOCK_RAW, IPPROTO_ICMP)) < 0) {
	perror("Couldn't open RAW socket");
	return 2;
    }
    if (setsockopt(sock_raw, IPPROTO_IP, IP_HDRINCL, &on, sizeof(on)) < 0) {
	perror("Couldn't setsockopt IP_HDRINCL");
	return 2;
    }

    s_ip = (struct ip *) &packet;
    s_icmp = (struct icmp *) &packet[sizeof(struct ip)];

    memset(packet, 0x00, 1500);

    sin.sin_addr.s_addr = inet_addr(host);
    sin.sin_port = 0;
    sin.sin_family = AF_INET;

    ti = time(NULL);
    
    s_ip->ip_src.s_addr = inet_addr(source);
    s_ip->ip_dst.s_addr = inet_addr(host);

    s_ip->ip_v = 4;
    s_ip->ip_hl = sizeof(struct ip) >> 2;
    s_ip->ip_len = sizeof(struct ip) + sizeof(struct icmp) + 4;
    s_ip->ip_id = 3000;
    s_ip->ip_off = 0;
    s_ip->ip_tos = 0;
    s_ip->ip_ttl = 255;
    s_ip->ip_p = IPPROTO_ICMP;
    s_ip->ip_sum = 0;

    s_icmp->icmp_type = ICMP_ECHO;
    s_icmp->icmp_code = 0;
    s_icmp->icmp_cksum = 0;
    s_icmp->icmp_seq = 1;
    s_icmp->icmp_id = htons( getpid() );

    t = (unsigned long *) &packet[sizeof(struct ip) + sizeof(struct icmp)];
    *t = ti;

    s_icmp->icmp_cksum = in_cksum((u_short *) s_icmp, sizeof( struct icmp ) + 4);

    gettimeofday( &bench, NULL );

    if (sendto(sock_raw, packet, sizeof(struct ip) + sizeof(struct icmp) + 4, 0, (struct sockaddr *) &sin, sizeof(struct sockaddr)) <= 0) {
	perror("sendto");
    }

    while (1) {
	if( time(NULL) > ti + 3 ){
	    break;
	}
	tv.tv_sec = 0;
	tv.tv_usec = 100000;

	FD_ZERO(&fds);
	FD_SET(sock_raw, &fds);

	select(sock_raw + 1, &fds, NULL, NULL, &tv);

	if (FD_ISSET( sock_raw, &fds) ) {
	    memset  ( packet, 0x00, 1500);
	    recvfrom( sock_raw, packet, 1500, 0, NULL, &sinlen);
	    if (s_ip->ip_p == IPPROTO_ICMP) {
		if (s_icmp->icmp_id == htons( getpid() ) && s_icmp->icmp_seq == 1 && *t == ti ) {
		    gettimeofday( &now, NULL );
		    start = ( bench.tv_sec * 1000000 ) + bench.tv_usec;
		    end   = ( now.tv_sec * 1000000 ) + now.tv_usec;
    
		    result = ( float )( end - start) / ( float )1000000 ;
		    
		    break;
		}
	    }
	}
    }
    close( sock_raw );
    return result;
}
