/***************************************************************************
    begin                : Sun Oct 05
    copyright            : (C) 2003 by Fabio Yasusi Yamamoto
    email                : fabio@hostname.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <stdarg.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <netinet/in.h>
#include <netdb.h>
#include <errno.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <sys/un.h>
#include <sys/errno.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <time.h>
#include <arpa/inet.h>

#include <openssl/ssl.h>

#include "socket.h"


struct s_buf_hdr *sock_buf_init(int fd, SSL * ssl_client)
{
    struct s_buf_hdr *s_buf;

    if (!(s_buf = (struct s_buf_hdr *) malloc(sizeof(struct s_buf_hdr)))) {
	perror("malloc");
	exit(0);
    }

    memset(s_buf, 0x00, sizeof(struct s_buf_hdr));

    s_buf->fd = fd;

    s_buf->ssl_client = ssl_client;

    return s_buf;
}
int my_memcpy( char * dest, char * orig, int size )
{
	int i;
	for( i=0;i<size;i++){
		dest[i]=orig[i];
	}
	return 1;
}
int sock_buf_read(struct s_buf_hdr *s_buf, char *data, int size)
{
    int s = 0;
    int readed = 0;
    char buffer[8192];

    /* Se o tamanho requisitado for menor do que o em memoria. apenas copie */
    if ( size <= s_buf->sock_buf_size) {
	my_memcpy(data, s_buf->sock_buf_data, size);

	/* Apaga pedaco ja lido da memoria */
	my_memcpy(s_buf->sock_buf_data, &s_buf->sock_buf_data[size], s_buf->sock_buf_size - size);

	s_buf->sock_buf_size = s_buf->sock_buf_size - size;
	s_buf->sock_buf_pos = 0;

	if(s_buf->sock_buf_size==0){
		free( s_buf->sock_buf_data );
		s_buf->sock_buf_data = NULL;
	} else {
		s_buf->sock_buf_data = realloc(s_buf->sock_buf_data, s_buf->sock_buf_size);
	}
	return size;
    } else {
	while ( size > s_buf->sock_buf_size) {
	    if( s_buf->ssl_client ){
		if ((s = sock_wait_for_data_ssl( s_buf->fd, s_buf->ssl_client, buffer, 8192, 120)) > 0) {
			s_buf->sock_buf_data = realloc(s_buf->sock_buf_data, s_buf->sock_buf_size + s);
			my_memcpy(&s_buf->sock_buf_data[s_buf->sock_buf_size], buffer, s);
			s_buf->sock_buf_size += s;
			readed += s;
			if( size <= s_buf->sock_buf_size ){
				break;
			}

		} else {
			break;
		}
	    } else {
		if ((s = sock_wait_for_data(s_buf->fd, buffer, 8192, 120)) > 0) {
			s_buf->sock_buf_data = realloc(s_buf->sock_buf_data, s_buf->sock_buf_size + s);
			my_memcpy(&s_buf->sock_buf_data[s_buf->sock_buf_size], buffer, s);
			s_buf->sock_buf_size += s;
			readed += s;
			if( size <= s_buf->sock_buf_size ){
				break;
			}
		} else {
			break;
		}
	    }
	}
	if (readed > 0) {
	    if ( size <= s_buf->sock_buf_size) {
		my_memcpy(data, s_buf->sock_buf_data, size);

		my_memcpy(s_buf->sock_buf_data, &s_buf->sock_buf_data[size], s_buf->sock_buf_size - size);

		s_buf->sock_buf_size = s_buf->sock_buf_size - size;
		s_buf->sock_buf_pos = 0;
		s_buf->sock_buf_data = realloc(s_buf->sock_buf_data, s_buf->sock_buf_size);

		return size;
	    } else {
		memcpy(data, s_buf->sock_buf_data, s_buf->sock_buf_size );

		free( s_buf->sock_buf_data );

		s_buf->sock_buf_data = NULL;

		s_buf->sock_buf_size =0 ;

		return s_buf->sock_buf_size;
	    }
	}
	return 0;
    }
}
int sock_buf_fill(struct s_buf_hdr *s_buf)
{
    int s = 0;
    int readed = 0;
    char buffer[8192];

    if (sock_have_data(s_buf->fd, 0, 10) == 1) {
	if( s_buf->ssl_client ){
		s = SSL_read(s_buf->ssl_client, buffer, 8192);
	} else {
		s = read(s_buf->fd, buffer, 8192);
	}

	if( s >0 ){
		s_buf->sock_buf_data = realloc(s_buf->sock_buf_data, s_buf->sock_buf_size + s);
		memcpy(&s_buf->sock_buf_data[s_buf->sock_buf_size], buffer, s);
		s_buf->sock_buf_size += s;

		readed += s;
	}
	if( s<= 0 ){
		return -1;
	}
    }
    return readed;
}
int sock_buf_close(struct s_buf_hdr *s_buf)
{
    if (s_buf->sock_buf_data) {
	free(s_buf->sock_buf_data);
    }
    s_buf->sock_buf_pos = 0;
    s_buf->sock_buf_size = 0;
    free(s_buf);
    return 1;
}


int sock_wait_for_data(int socket, char *buffer, int size, int tm)
{
    int s;
    fd_set fds;
    struct timeval tv;

    FD_ZERO(&fds);
    FD_SET(socket, &fds);

    tv.tv_sec = tm;
    tv.tv_usec = 0;

    select(socket + 1, &fds, NULL, NULL, &tv);
    if (FD_ISSET(socket, &fds)) {
	s = read(socket, buffer, size);
	if (s > 0) {
	    return s;
	} else {
	    return -1;
	}
	return s;
    }

    return 0;
}

int sock_can_write(int socket, int s, int m)
{
    fd_set fds;
    struct timeval tv;


    FD_ZERO(&fds);
    FD_SET(socket, &fds);

    tv.tv_sec = s;
    tv.tv_usec = m;

    if (select(socket + 1, NULL, &fds, NULL, &tv) == -1) {
	return 0;
    }
    if (FD_ISSET(socket, &fds)) {
	return 1;
    }
    return 0;
}
int sock_have_data(int socket, int s, int m)
{
    fd_set fds;
    struct timeval tv;

    FD_ZERO(&fds);
    FD_SET(socket, &fds);

    tv.tv_sec = s;
    tv.tv_usec = m;

    select(socket + 1, &fds, NULL, NULL, &tv);
    if (FD_ISSET(socket, &fds)) {
	return 1;
    }
    return 0;
}
int sock_connect_tcp(char *ip, int port, int tout)
{
    fd_set fds;
    struct timeval tv;

    int sockfd;
    int sinlen;
    int tTime;

    struct sockaddr_in daddr;
    struct sockaddr_in sin;
    struct hostent *h;

    sinlen = sizeof(struct sockaddr_in);

    if ((h = gethostbyname(ip)) == NULL) {
	return -1;
    }

    sockfd = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);

    fcntl(sockfd, F_SETFL, O_NONBLOCK | O_RDWR);

    daddr.sin_family = AF_INET;
    daddr.sin_port = htons(port);
    memcpy(&daddr.sin_addr, h->h_addr_list[0], sizeof(struct in_addr));

    if ((connect(sockfd, (struct sockaddr *) &daddr, sizeof(struct sockaddr_in))) < 0) {
	if ((errno != EALREADY) && (errno != EINPROGRESS)) {
	    perror("connect failed");
	    close(sockfd);
	    return -1;
	}
    }

    tTime = time(NULL);
    do {
	if (time(NULL) > tTime + tout) {
	    return -1;
	}
	tv.tv_sec = 0;
	tv.tv_usec = 100000;

	FD_ZERO(&fds);
	FD_SET(sockfd, &fds);

	select(sockfd + 1, &fds, NULL, NULL, &tv);
	if (FD_ISSET(sockfd, &fds)) {
	    if (getpeername(sockfd, (struct sockaddr *) &sin, &sinlen) == -1) {
		return -1;
	    } else {
		fcntl(sockfd, F_SETFL, O_RDWR);
		return sockfd;
	    }
	}
	if (getpeername(sockfd, (struct sockaddr *) &sin, &sinlen) == 0) {
	    fcntl(sockfd, F_SETFL, O_RDWR);
	    return sockfd;
	}
    } while (1);
}

int sock_readline(int sock, char *buffer, int size, int tm)
{
    char c;
    int i = 0;

    do {
	if ((sock_wait_for_data(sock, &c, 1, tm)) <= 0) {
	    return -1;
	}
	if (c != 0x0a && c != 0x0d) {
	    buffer[i++] = c;
	}
    } while (c != 0x0a && i < size);

    buffer[i] = 0x00;
    return i;
}
int sock_buf_readline(struct s_buf_hdr *s_buf, char *buffer, int size, int tm)
{
    char c;
    int i = 0;
    int d;

    do {
	if ((d = sock_buf_read(s_buf, &c, 1)) <= 0) {
	    return -1;
	}
	if (c != 0x0a && c != 0x0d) {
	    buffer[i++] = c;
	}
    } while (c != 0x0a && i < size);

    buffer[i] = 0x00;
    return i;
}

int sock_printf(int socket,SSL * ssl_client, char *msg01, ...)
{
    int size;
    char temp01[1024];
    va_list args;

    va_start(args, msg01);
    vsnprintf(temp01, 1024, msg01, args);
    va_end(args);

    size = strlen(temp01);
    if (sock_can_write(socket, 30, 0)) {
    	if( ssl_client ){
		SSL_write(ssl_client, temp01, size);
	} else {
		if (write(socket, temp01, size) == -1) {
			return -1;
		}
	}
    }

    return 0;
}
int sock_poll(int socket, int tm)
{
    fd_set fds;
    struct timeval tv;

    FD_ZERO(&fds);
    FD_SET(socket, &fds);

    tv.tv_sec = tm;
    tv.tv_usec = 0;

    select(socket + 1, &fds, NULL, NULL, &tv);
    if (FD_ISSET(socket, &fds)) {
	return 1;
    }
    return 0;
}

int sock_bind_udp(int port)
{
    int SUDP;
    struct sockaddr_in saddr;
    if ((SUDP = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP)) < 0) {
	perror("socket");
	exit(0);
    }
    saddr.sin_addr.s_addr = inet_addr("0.0.0.0");
    saddr.sin_family = AF_INET;
    saddr.sin_port = htons(port);

    if (bind(SUDP, (struct sockaddr *) &saddr, sizeof(struct sockaddr)) < 0) {
	perror("bind");
	exit(0);
    }
    return SUDP;
}
int sock_bind_tcp(int port)
{
    int STCP;
    int reuse = 1;
    struct sockaddr_in saddr;
    if ((STCP = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP)) < 0) {
	perror("socket");
	exit(0);
    }
    if (setsockopt(STCP, SOL_SOCKET, SO_REUSEADDR, &reuse, sizeof(reuse)) < 0) {
	perror("setsockopt");
	exit(1);
    }

    saddr.sin_addr.s_addr = inet_addr("0.0.0.0");
    saddr.sin_family = AF_INET;
    saddr.sin_port = htons(port);

    if (bind(STCP, (struct sockaddr *) &saddr, sizeof(struct sockaddr)) < 0) {
	perror("bind");
	exit(0);
    }
    listen(STCP, -1);
    return STCP;
}
int sock_persistent_read(int sock, char *buffer, int buf_size)
{
    int size = 0;
    int pos = 0;

    while (pos < buf_size) {
	if (sock_have_data(sock, 120, 0)) {
	    if ((size = sock_wait_for_data(sock, &buffer[pos], buf_size - pos, 10)) < 0) {
//          if ((size = read(sock, &buffer[pos], buf_size - pos)) < 0) {
		return -1;
	    }
	    if (size == 0) {
		return pos;
	    }
	}
	pos += size;
    }
    return pos;
}
int sock_connect_unix(char *filename)
{
    int SX1;
    struct sockaddr_un un;

    if ((SX1 = socket(AF_UNIX, SOCK_STREAM, 0)) == -1) {
	perror("socket");
	exit(1);
    }

    un.sun_family = AF_UNIX;
    strcpy(un.sun_path, filename);
    if ((connect(SX1, (struct sockaddr *) &un, sizeof(struct sockaddr_un))) == -1) {
	close(SX1);
	return -1;
    }
    return SX1;
}
int sock_bind_unix(char *filename)
{
    int SX1;
    struct sockaddr_un un;

    if ((SX1 = socket(AF_UNIX, SOCK_STREAM, 0)) == -1) {
	perror("socket");
	exit(1);
    }
    unlink(filename);
    un.sun_family = AF_UNIX;
    strcpy(un.sun_path, filename);
    bind(SX1, (struct sockaddr *) &un, strlen(un.sun_path) + 2);
    listen(SX1, 255);
    return SX1;
}

int sock_wait_for_data_ssl(int socket, SSL * ssl_client, char *buffer, int size, int tm)
{
    int s;
    fd_set fds;
    struct timeval tv;

    FD_ZERO(&fds);
    FD_SET(socket, &fds);

    tv.tv_sec = tm;
    tv.tv_usec = 0;

    select(socket + 1, &fds, NULL, NULL, &tv);
    if (FD_ISSET(socket, &fds)) {
	s = SSL_read(ssl_client, buffer, size);

	write( 1,buffer, s );
	if (s > 0) {
	    return s;
	} else {
	    return -1;
	}
	return s;
    }
    return 0;
}



char *sock_read_buffer(int sock, int max_size)
{
    int s;
    char *result = NULL;
    char buffer[8192];
    int totlen = 0;

    while ((s = read(sock, buffer, 8192)) > 0) {
	result = realloc(result, totlen + s + 1);
	memcpy(&result[totlen], buffer, s);
	totlen += s;
	result[totlen] = 0x00;
    }
    return result;
}

unsigned long get_local_address( int sock )
{
	int slen;
	struct sockaddr_in sin;
	slen = sizeof( struct sockaddr_in );


	if( getsockname( sock, ( struct sockaddr * )&sin, &slen ) <0 ){
		return -1;
	}

	return sin.sin_addr.s_addr;
}
unsigned long sock_my_address( char * host )
{
	int sock;
	struct sockaddr_in sin;

	int slen=sizeof( struct sockaddr_in);

	sock = socket( AF_INET, SOCK_DGRAM, IPPROTO_UDP );

	sin.sin_family = AF_INET;
	sin.sin_port   = htons(1);
	sin.sin_addr.s_addr = inet_addr( host );

  	if( connect(sock,(struct sockaddr *)&sin, sizeof(struct sockaddr_in)) == -1 ){
		close( sock );
	}
	if( getsockname( sock, ( struct sockaddr *)&sin, &slen )<0 ){
		perror("getsockname");
		exit  ( 0 );
		return 0;
	}
	return sin.sin_addr.s_addr;
}
