/***************************************************************************
    begin                : Sun Oct 05
    copyright            : (C) 2003 by Fabio Yasusi Yamamoto
    email                : fabio@hostname.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <netinet/in.h>
#include <netdb.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <sys/un.h>
#include <sys/errno.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <time.h>
#include <arpa/inet.h>

#include <openssl/ssl.h>

#include "socket.h"

#include "NatACL.h"
#include "http.h"
#include "webserver.h"
#include "html.h"

#include "auth.h"
#include "log.h"

int handle_webserver( struct s_data_hdr * s_data, struct s_connection_hdr * s_fd )
{
	int temp;
	char buffer[8192];

	if( !s_fd->s_buf ){
		if( s_fd->ssl ){
			s_fd->s_buf = sock_buf_init( s_fd->fd, s_fd->ssl_client );
		} else {
			s_fd->s_buf = sock_buf_init( s_fd->fd, NULL );
		}
	}

	if( sock_buf_fill( s_fd->s_buf ) <=0 ){
		return 0;
	}
	if( s_fd->s_buf->sock_buf_size <4 ){
		return 1;
	}
	while( have_crlf( s_fd->s_buf->sock_buf_data, s_fd->s_buf->sock_buf_size )  ){
		sock_buf_readline(s_fd->s_buf, buffer, 8192, 0 );

		s_fd->s_http = http_decode_line(s_fd->s_http, buffer);
	}
	if( s_fd->s_http ){

		if( check_address( s_data, inet_addr(s_fd->source_addr) ) ){
			if( s_fd->s_http->status ){
				if( s_fd->s_http->method == METHOD_POST ){
		

			if( s_fd->s_buf->sock_buf_size == s_fd->s_http->content_length ){
						temp = s_fd->s_buf->sock_buf_size;

						s_fd->s_http->post 	= realloc( s_fd->s_http->post, s_fd->s_http->post_size + s_fd->s_buf->sock_buf_size + 1);

						sock_buf_read( s_fd->s_buf , &s_fd->s_http->post[s_fd->s_http->post_size], s_fd->s_buf->sock_buf_size );

						memcpy( s_fd->s_http->post, buffer, s_fd->s_buf->sock_buf_size );

						s_fd->s_http->post_size += temp;
						
						s_fd->s_http->post[s_fd->s_http->post_size]=0x00;
					}
				}
			}

			if( s_fd->s_http->status ){
				switch( s_fd->s_http->method ){
					case METHOD_POST:
						if( s_fd->s_http->post_size == s_fd->s_http->content_length ){
							webserver_post( s_data, s_fd );
							return 0;
						} else {
							return 1;
						}
					break;
					case METHOD_GET:
						if( webserver_get ( s_data, s_fd ) == 0 ){
						    return 0;
						} else {
						    return 1;
						}
					break;
					default:
						printf("UNKNOW DATA\n");
						fflush(stdout);
					break;
				}
			}
		} else {
			webserver_denied( s_data,  s_fd );
			return 0;
		}
	}
	return 1;
}
int webserver_get( struct s_data_hdr * s_data, struct s_connection_hdr * s_fd )
{
	int result = 0;
	int size;
	int slen = sizeof( struct sockaddr_in );

	char * form_url;
	struct s_template * s_html;
	struct sockaddr_in sin;
	char * form_popup;
	struct s_queue_auth_hdr * s_user;

	if( s_fd->ssl ){
		if((form_url  = http_parse_get(s_fd->s_http->url, strlen(s_fd->s_http->url), "URL"))){
			size   = strlen( s_fd->s_http->url );
			if((s_html = template_init( "/var/NatACL/html/login.html"))){
				template_write  ( s_html, "URL", form_url );
				template_show_fd( s_html, s_fd->fd, s_fd->ssl_client );
			}
			free( form_url );
		}
	} else {
		form_url  = http_parse_get(s_fd->s_http->url, strlen(s_fd->s_http->url), "URL");

		if((form_popup  = http_parse_get(s_fd->s_http->url, strlen(s_fd->s_http->url), "POPUP"))){
            	    sock_printf( s_fd->fd, s_fd->ssl_client, "HTTP/1.1 200 OK\r\n"
                    "Server: NatACL 2.0b\r\n"
                    "Content-Type: text/html\r\n"
                    "Cache-Control: no-store\r\n"
                    "Connection: Keep-Alive\r\n"
		    
                    "Pragma: no-cache\r\n\r\n" );

		    s_user = get_user_by_host( s_data->s_user_queue, inet_addr(s_fd->source_addr) );
		    if( s_user && s_user->keepalive == 1 ){
			getsockname( s_fd->fd, ( struct sockaddr *)&sin, &slen );

			s_user->keepalive = 2;

			setsockopt( s_fd->fd, SOL_SOCKET, SO_KEEPALIVE, (char *)s_fd->keepalive, sizeof( SO_KEEPALIVE ));
		    
			add_rule( s_data, s_fd->source_addr );
			s_fd->keepalive = 2;
			result = 1;

    			sock_printf( s_fd->fd,s_fd->ssl_client, "<script type=\"text/javascript\" language=\"JavaScript\">"
    			"function clear( url )" 
    			"{"
    			"window.opener.location.href=url;"
    			"return;"
    			"}"
    			"</script>"
    			"<body onload=\"clear('%s')\"   bgcolor=#303030>" , form_url);
    					
			sock_printf( s_fd->fd, s_fd->ssl_client, "<table><tr><td><font color=#dddddd>USER:</font></td><td><font color=#ffffff>%s</font></td></tr></table><font color=#dddddd> <BR> This window keeps you logged on the network, close-it to logout</font>",s_user->name );
		    }
		} else {
            	    sock_printf( s_fd->fd, s_fd->ssl_client, "HTTP/1.0 200 OK\r\n"
                    "Server: NatACL 2.0b\r\n"
                    "Content-Type: text/html\r\n"
                    "Cache-Control: no-store\r\n"
                    "Pragma: no-cache\r\n\r\n" );

		    getsockname( s_fd->fd, ( struct sockaddr *)&sin, &slen );

		    sock_printf( s_fd->fd, s_fd->ssl_client, "<html>\r\n<head>\r\n<meta http-equiv=refresh content=\"0;url=https://%s:5122/?URL=%s%s\"></head></html>", inet_ntoa(sin.sin_addr ), s_fd->s_http->host,s_fd->s_http->url );
		}
	}
	return result;
}
char * gen_filename_log( char * prefix, char * postfix)
{
    char * result = NULL;
    char tmp[255];

    struct timeval tv;
    struct      tm      *tm;
    int t;
    
    time( &t );    
    tm = localtime(&t);
    
    strftime(tmp, 255, "%Y%m%d", tm );
    
    result = calloc( 1, 255 );

    snprintf( result, 255,"%s/%s", prefix, tmp );
    mkdir( result, 0700 );

    snprintf( result, 255,"%s/%s/NatACL.%s", prefix, tmp, postfix );
    
    return result;
}
int webserver_post( struct s_data_hdr * s_data, struct s_connection_hdr * s_fd )
{
	char * form_user;
	char * form_password;
	char * form_url;
	unsigned long local_address;
	struct in_addr in;
	char * filename_idx;
	char * filename_bin;

	struct s_user_hdr * s_user;

	form_user 	  = http_parse_get(s_fd->s_http->post, strlen(s_fd->s_http->post), "USER");
	form_password 	  = http_parse_get(s_fd->s_http->post, strlen(s_fd->s_http->post), "PASSWORD");
	form_url 	  = http_parse_get(s_fd->s_http->post, strlen(s_fd->s_http->post), "URL");

	if( !form_user ){
		sock_printf( s_fd->fd, s_fd->ssl_client, "HTTP/1.0 200 OK\r\n"
			"Server: NatACL 2.0b\r\n"
			"Content-Type: text/html\r\n"
			"Cache-Control: no-store\r\n"
			"Pragma: no-cache\r\n\r\n" );

		sock_printf( s_fd->fd,s_fd->ssl_client,"Missing USER\n");
		return 0;
	}
	if( !form_password ){
		sock_printf( s_fd->fd, s_fd->ssl_client, "HTTP/1.0 200 OK\r\n"
			"Server: NatACL 2.0b\r\n"
			"Content-Type: text/html\r\n"
			"Cache-Control: no-store\r\n"
			"Pragma: no-cache\r\n\r\n" );

		sock_printf( s_fd->fd,s_fd->ssl_client,"Missing PASSWORD\n");
		return 0;
	}
	if( !form_url ){
		sock_printf( s_fd->fd, s_fd->ssl_client, "HTTP/1.0 200 OK\r\n"
			"Server: NatACL 2.0b\r\n"
			"Content-Type: text/html\r\n"
			"Cache-Control: no-store\r\n"
			"Pragma: no-cache\r\n\r\n" );

		sock_printf( s_fd->fd,s_fd->ssl_client,"Missing URL\n");
		return 0;
	}

	if((s_user = auth_vrfy( s_data, form_user, form_password, s_fd->source_addr ))){
		filename_idx = gen_filename_log( FILE_BIN_IDX, "idx" );
		filename_bin = gen_filename_log( FILE_BIN_LOG, "bin" );
		
		blog_add( filename_bin, filename_idx, form_user, inet_addr(s_fd->source_addr), ACTION_GRANTED );

		sock_printf( s_fd->fd, s_fd->ssl_client, "HTTP/1.0 200 OK\r\n"
			"Server: NatACL 2.0b\r\n"
			"Content-Type: text/html\r\n"
			"Cache-Control: no-store\r\n"
			"Pragma: no-cache\r\n\r\n" );

		local_address = get_local_address( s_fd->fd );

		s_data->s_user_queue = add_queue_auth( s_data->s_user_queue, form_user, time(NULL), s_user->type, s_user->tv, inet_addr(s_fd->source_addr), local_address );


		if( s_user->type == TYPE_EXPIRE_POPUP ){
		    in.s_addr = local_address;
		    sock_printf( s_fd->fd,s_fd->ssl_client, "<SCRIPT TYPE=\"text/javascript\">"
							"function popup(link, windowname)"
							"{"
							"window.open(link, windowname, 'width=250,height=100,scrollbars=no');"
							"return false;"
							"}"
							"</SCRIPT>"
							"<BODY onLoad=\"popup('http://%s:5121/?POPUP=YES&URL=%s', 'ad')\">",inet_ntoa( in ), form_url );
			
    		    wlog( FILE_LOG,"[NatACL] [WAITING POPUP]: %s %d %d %d %s",form_user, time(NULL), s_user->type, s_user->tv, s_fd->source_addr );

		    s_data->s_user_queue->s_last->keepalive = 1;

		    sock_printf( s_fd->fd,s_fd->ssl_client, "<html>\r\n<head>\r\n<meta http-equiv=refresh content=\"2;url=http://%s\"></head></html>", form_url );

		} else {
		    sock_printf( s_fd->fd,s_fd->ssl_client, "<html>\r\n<head>\r\n<meta http-equiv=refresh content=\"0;url=http://%s\"></head></html>", form_url );
		    add_rule( s_data, s_fd->source_addr );
    		    wlog( FILE_LOG,"[NatACL] GRANT: %s %d %d %d %s",form_user, time(NULL), s_user->type, s_user->tv, s_fd->source_addr );
		}
		free( s_user );
		
    		free( filename_idx );
		free( filename_bin );

	} else {
		filename_idx = gen_filename_log( FILE_BIN_IDX, "idx" );
		filename_bin = gen_filename_log( FILE_BIN_LOG, "bin" );

		blog_add( filename_bin, filename_idx, form_user,  inet_addr(s_fd->source_addr),ACTION_DENIED );
		
		webserver_denied( s_data, s_fd );
        	free( filename_idx );
		free( filename_bin );
	}
	return 0;
}
int webserver_denied( struct s_data_hdr * s_data, struct s_connection_hdr * s_fd )
{
        sock_printf( s_fd->fd, s_fd->ssl_client,"HTTP/1.0 403 Forbidden\r\n"
                    "Server: NatACL 2.0b\r\n"
                    "Content-Type: text/html\r\n"
                    "Cache-Control: no-store\r\n"
                    "Pragma: no-cache\r\n\r\n" );


	sock_printf( s_fd->fd,s_fd->ssl_client, "<html><head><title>403 Forbidden</title></head><body><h1>Access DENIED</h1> - IP address/Login/Password not allowed<hr /> - <a href=\"http://www.hostname.org/netacl\">NatACL 2.0</a></body></html>\n");
	return 0;
}



