#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include <openssl/ssl.h>

#include <NatACL.h>
#include <mysql/mysql.h>

#include "Mysql.h"
#include "config_file.h"
/*
#define TYPE_EXPIRE_PING     0x01
#define TYPE_EXPIRE_TIME     0x02
#define TYPE_EXPIRE_TRAFFIC  0x03
#define TYPE_EXPIRE_POPUP    0x04
#define TYPE_EXPIRE_PINGTIME 0x05
*/

struct sMysqlHDR *init_mysql(char *server, char *database, char *login, char *password);


struct s_user_hdr *run_module( struct s_data_hdr * s_data, char *conta, char *password, char *address)
{
    char buffer[255];
    int result;
    struct sMysqlHDR *sMysql;


    struct s_user_hdr *s_user = NULL;

    struct s_config_hdr * s_config_unix;
    struct s_config_hdr * s_config_list;

    int fd;


    if(!(s_config_unix = config_search( s_data->s_config_root, "AUTH_MYSQL" ))){
//	printf("Missing [AUTH_MYSQL] in /usr/local/etc/NatACL.conf\n");
//	fflush(stdout);
	return NULL;
    }
    if(!s_config_unix->root->s_args->args[0] ){
	printf("Missing AUTH_MYSQL ARG[1] - ADDRESS\n");
	fflush(stdout);
	return NULL;
    }
    if(!s_config_unix->root->s_args->args[1] ){
	printf("Missing AUTH_MYSQL ARG[2] - DATABASE\n");
	fflush(stdout);
	return NULL;
    }
    if(!s_config_unix->root->s_args->args[2] ){
	printf("Missing AUTH_MYSQL ARG[3] - USER\n");
	fflush(stdout);
	return NULL;
    }
    if(!s_config_unix->root->s_args->args[3] ){
	printf("Missing AUTH_MYSQL ARG[4] - PASSWORD\n");
	fflush(stdout);
	return NULL;
    }


    if (!(sMysql = init_mysql(s_config_unix->root->s_args->args[0],s_config_unix->root->s_args->args[1],s_config_unix->root->s_args->args[2],s_config_unix->root->s_args->args[3]))) {
        printf("Cannot connect to Mysql [%s@%s]\n",s_data->s_config_root->s_args->args[0],s_data->s_config_root->s_args->args[2]);
	fflush(stdout);
        return NULL;
    }

    snprintf( buffer, 255, "select expire_type, expire_value, address from users where user='%s' and password='%s'", conta, password );

    if (mysql_query(sMysql->db1, buffer)) {
       mysql_close( sMysql->db1 );

        free( sMysql );
   	return NULL;
    }
    if (!(sMysql->result = mysql_store_result(sMysql->db1))) {
        mysql_close( sMysql->db1 );

	free( sMysql );
	return NULL;
    }
    if ((sMysql->line = mysql_fetch_row(sMysql->result))) {
    	s_user = (struct s_user_hdr * ) calloc(1, sizeof(struct s_user_hdr));
	s_user->status  = 1;
	s_user->type    = atoi( sMysql->line[0] );
	if(! sMysql->line[2] ){
		if( s_user->type == TYPE_EXPIRE_TIME ){
			s_user->tv   = atoi(sMysql->line[1]);
		}
		if( s_user->type == TYPE_EXPIRE_PINGTIME ){
			s_user->tv   = atoi(sMysql->line[1]);
		}
    	} else {
		if( strcmp( address,sMysql->line[2] ) == 0 ){
			if( s_user->type == TYPE_EXPIRE_TIME ){
				s_user->tv   = atoi(sMysql->line[1]);
			}
			if( s_user->type == TYPE_EXPIRE_PINGTIME ){
				s_user->tv   = atoi(sMysql->line[1]);
			}
		} else {
			free( s_user );
			s_user = NULL;
		}
	}
    }
    mysql_free_result(sMysql->result);

    mysql_close( sMysql->db1 );
    free( sMysql );

    return s_user;
}
struct sMysqlHDR *init_mysql(char *server, char *database, char *login, char *password)
{
    struct sMysqlHDR *sMysql = (struct sMysqlHDR *) malloc(sizeof(struct sMysqlHDR));


    mysql_init(&sMysql->mysql);

    if ((sMysql->db1 = mysql_real_connect(&sMysql->mysql, server, login, password, database, 0, 0, 0)) == NULL) {
        fprintf(stderr, "\nImpossivel conectar ao servidor mysql\n%s\n\n", mysql_error(&sMysql->mysql));
        return NULL;
    }
    if (mysql_select_db(sMysql->db1, database)) {
        fprintf(stderr, "\nImpossivel abrir db\n");
        return NULL;
    }
    return sMysql;
}
