#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <pwd.h>

#include <openssl/ssl.h>

#include <NatACL.h>

#ifdef HAVE_SHADOW_H
#include <shadow.h>
#endif

#include "main.h"
#include "config_file.h"
/*
#define TYPE_EXPIRE_PING    0x01
#define TYPE_EXPIRE_TIME    0x02
#define TYPE_EXPIRE_TRAFFIC 0x03
#define TYPE_EXPIRE_POPUP   0x04
*/

struct s_user_hdr *run_module( struct s_data_hdr * s_data, char *conta, char *password, char *address)
{
    int result;
    struct passwd *pwd;
    char *epwd;

    struct s_user_hdr *s_user = NULL;

    struct s_config_hdr * s_config_unix;
    struct s_config_hdr * s_config_list;

#ifdef HAVE_SHADOW_H
    struct spwd *sh;
#endif
    int fd;


    if(!(s_config_unix = config_search( s_data->s_config_root, "AUTH_UNIX" ))){
	printf("Missing [AUTH_UNIX] in /usr/local/etc/NatACL.conf\n");
	exit  ( 0 );
    }


    if (strcmp(conta, "root") == 0) {
	return NULL;
    }
#ifdef HAVE_SHADOW_H
    if (!(sh = getspnam(conta))) {
	return NULL;
    }
    epwd = crypt(password, sh->sp_pwdp);

    if (strcmp(epwd, sh->sp_pwdp) == 0) {
	s_user = (struct s_user_hdr * ) calloc(1, sizeof(struct s_user_hdr));
	s_user->status = 1;
    }
#else
    if (!(pwd = getpwnam(conta))) {
	return NULL;
    }
    epwd = crypt(password, pwd->pw_passwd);
    if (strcmp(epwd, pwd->pw_passwd) == 0) {
	s_user = (struct s_user_hdr * ) calloc(1, sizeof(struct s_user_hdr));
	s_user->status = 1;
    } 
#endif

    if( !s_user ){
    	return NULL;
    }

    s_config_list = s_config_unix->root;
    while( s_config_list ){
	if( strcmp( s_config_list->s_args->args[0], "TYPE" ) == 0 ){
		if( strcmp( s_config_list->s_args->args[1], "EXPIRE_TIME" ) == 0 ){
			s_user->type = TYPE_EXPIRE_TIME;
			if( s_config_list->s_args->args[2] ){
				s_user->tv   = atoi(s_config_list->s_args->args[2]);
			}
		}
		else if( strcmp( s_config_list->s_args->args[1], "EXPIRE_PING" ) == 0 ){
			s_user->type = TYPE_EXPIRE_PING;
		}
		else if( strcmp( s_config_list->s_args->args[1], "EXPIRE_POPUP" ) == 0 ){
			s_user->type = TYPE_EXPIRE_POPUP;
		}
		else if( strcmp( s_config_list->s_args->args[1], "EXPIRE_PINGTIME" ) == 0 ){
			s_user->type = TYPE_EXPIRE_PINGTIME;
			if( s_config_list->s_args->args[2] ){
				s_user->tv   = atoi(s_config_list->s_args->args[2]);
			}
		}
	}
	s_config_list = s_config_list->right;
    }


    return s_user;
}
